# $Id$
## @file
# Top level makefile.
#

#
# Copyright (C) 2006-2017 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#

SUB_DEPTH = .
include $(KBUILD_PATH)/subheader.kmk

#
# Sub-makefiles / Sub-directories.
#
ifndef VBOX_ONLY_ROOT_MAKEFILE
 if  (defined(VBOX_WITH_DOCS) || defined(VBOX_WITH_MAIN)) \
  && (!defined(VBOX_ONLY_BUILD) || defined(VBOX_ONLY_DOCS) || defined(VBOX_ONLY_SDK))
  include $(PATH_SUB_CURRENT)/doc/manual/Makefile.kmk
 endif
 include $(PATH_SUB_CURRENT)/src/Makefile.kmk
 ifdef VBOX_WITH_INCLUDE_SYNTAX_CHECKING
  include $(PATH_SUB_CURRENT)/include/Makefile.kmk
 endif
endif

#
# Below we might need TOOL_ZIP_UNPACK (for the additions/docs/efifw packages
# from the build server), and it's not really worth the effort of dragging in
#q this tool only if absolutely needed.
#
## @todo Hack to get at TOOL_ZIP_UNPACK; see if this can be integrated somehow...
include $(KBUILD_PATH)/tools/ZIP.kmk
ifndef TOOL_ZIP_PACK
 TOOL_ZIP_PACK = zip
endif


## @todo split up this file!


#
# Clean up global stuff that Config.kmk generates.
#
OTHER_CLEAN += \
	$(VBOX_PACKAGE_HEADER) \
	$(VBOX_LICENSE_VER_KMK) \
	$(VBOX_VERSION_MK) \
	$(VBOX_VERSION_HEADER) \
	$(VBOX_VERSION_STAMP) \
	$(wildcard $(PATH_OUT)/version-stamp-*.*.*) \
	$(VBOX_SVN_REV_KMK).ts \
	$(VBOX_SVN_REV_KMK) \
	$(PATH_OUT)/DynamicConfig.kmk


if  !defined(VBOX_ONLY_ADDITIONS) \
 && !defined(VBOX_ONLY_DOCS) \
 && !defined(VBOX_ONLY_EXTPACKS) \
 && !defined(VBOX_ONLY_VALIDATIONKIT) # -> line 426b ;-)

 if !defined(VBOX_OSE) && defined(VBOX_LICENSE_FILES)
  #
  # Install the license (and misc non-executable stuff).
  #
  INSTALLS += InstallLicenseFiles
  InstallLicenseFiles_INST = $(INST_BIN)
  InstallLicenseFiles_MODE = 0644
  InstallLicenseFiles_SOURCES =
  InstallLicenseFiles_SOURCES += \
  	$(VBOX_BRAND_LICENSE_HTML)=>License-$(VBOX_LICENSE_VER).html \
 	$(foreach f,$(VBOX_INSTALLER_ADD_LANGUAGES),$(VBOX_BRAND_$(f)_LICENSE_HTML)=>License-$(VBOX_LICENSE_VER)-$(f).html)
 endif


#
# Install external binaries (mostly redistributable parts of tools we use).
#
# To avoid dragging in unnecessary tools and sdks here, we don't use the .win
# and .linux property suffixes.
#
INSTALLS += InstallExternalLibs

InstallExternalLibs_INST = $(INST_BIN)

# The SDL DLLs
if1of ($(KBUILD_TARGET), win os2)
 ifdef VBOX_WITH_VBOXSDL
  include $(KBUILD_PATH)/sdks/LIBSDL.kmk
  InstallExternalLibs_SOURCES += \
	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(DLL_SDK_LIBSDL_SDL))
  ifdef VBOX_WITH_SECURELABEL
   InstallExternalLibs_SOURCES += \
	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(DLL_SDK_LIBSDL_SDLTTF))
  endif
  ifeq ($(KBUILD_TARGET),os2)
   InstallExternalLibs_SOURCES += \
	$(DLL_SDK_LIBSDL_FSLIB)
  endif
 endif
endif


# The compiler runtime DLLs.
ifeq ($(KBUILD_TARGET).$(VBOX_WITHOUT_COMPILER_REDIST),win.)
 include $(KBUILD_PATH)/tools/$(VBOX_VCC_TOOL).kmk
 include $(KBUILD_PATH)/tools/$(VBOX_VCC_TOOL_STEM)X86.kmk
 VBOX_VCC_REDIR_BASE             := Microsoft.VC$(substr $(VBOX_VCC_TOOL),4,3)
 VBOX_PATH_VCC_REDIST             = $(PATH_TOOL_$(VBOX_VCC_TOOL))/redist/
 VBOX_PATH_VCC_REDIST_CRT         = $(VBOX_PATH_VCC_REDIST)/$(subst amd64,x64,$(KBUILD_TARGET_ARCH))/$(VBOX_VCC_REDIR_BASE).CRT
 VBOX_PATH_VCC_REDIST_CRT_DBG     = $(VBOX_PATH_VCC_REDIST)/Debug_NonRedist/$(subst amd64,x64,$(KBUILD_TARGET_ARCH))/$(VBOX_VCC_REDIR_BASE).DebugCRT
 VBOX_PATH_VCC_REDIST_CRT_X86     = $(VBOX_PATH_VCC_REDIST)/x86/$(VBOX_VCC_REDIR_BASE).CRT
 VBOX_PATH_VCC_REDIST_CRT_DBG_X86 = $(VBOX_PATH_VCC_REDIST)/Debug_NonRedist/x86/$(VBOX_VCC_REDIR_BASE).DebugCRT

 InstallExternalLibs_SOURCES += \
 	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT)/msvcr$(substr $(VBOX_VCC_TOOL_STEM),4).dll) \
 	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT)/msvcp$(substr $(VBOX_VCC_TOOL_STEM),4).dll) \
 	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT)/msvcr$(substr $(VBOX_VCC_TOOL_STEM),4).dll)=>testcase/msvcr$(substr $(VBOX_VCC_TOOL_STEM),4).dll \
 	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT)/msvcp$(substr $(VBOX_VCC_TOOL_STEM),4).dll)=>testcase/msvcp$(substr $(VBOX_VCC_TOOL_STEM),4).dll
 ifdef VBOX_WITH_32_ON_64_MAIN_API
  InstallExternalLibs_SOURCES += \
  	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT_X86)/msvcr$(substr $(VBOX_VCC_TOOL_STEM),4).dll,x86_)=>x86/msvcr$(substr $(VBOX_VCC_TOOL_STEM),4).dll \
  	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT_X86)/msvcp$(substr $(VBOX_VCC_TOOL_STEM),4).dll,x86_)=>x86/msvcp$(substr $(VBOX_VCC_TOOL_STEM),4).dll
 endif
 ifeq ($(VBOX_VCC_CRT_TYPE),d)
  InstallExternalLibs_SOURCES += \
  	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT_DBG)/msvcr$(substr $(VBOX_VCC_TOOL_STEM),4)d.dll) \
  	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT_DBG)/msvcp$(substr $(VBOX_VCC_TOOL_STEM),4)d.dll) \
  	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT_DBG)/msvcr$(substr $(VBOX_VCC_TOOL_STEM),4)d.dll)=>testcase/msvcr$(substr $(VBOX_VCC_TOOL_STEM),4)d.dll \
  	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT_DBG)/msvcp$(substr $(VBOX_VCC_TOOL_STEM),4)d.dll)=>testcase/msvcp$(substr $(VBOX_VCC_TOOL_STEM),4)d.dll
  ifdef VBOX_WITH_32_ON_64_MAIN_API
  InstallExternalLibs_SOURCES += \
  	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT_DBG_X86)/msvcr$(substr $(VBOX_VCC_TOOL_STEM)d,4).dll,x86_)=>x86/msvcr$(substr $(VBOX_VCC_TOOL_STEM),4)d.dll \
  	$(call VBOX_RE_SIGN_DLL_FN,InstallExternalLibs,$(VBOX_PATH_VCC_REDIST_CRT_DBG_X86)/msvcp$(substr $(VBOX_VCC_TOOL_STEM)d,4).dll,x86_)=>x86/msvcp$(substr $(VBOX_VCC_TOOL_STEM),4)d.dll
  endif
 endif
endif

#
# Install our Qt DLLs / Shared Objects / Frameworks.
# Note: The installer fixes the darwin .dylibs when hardening is enabled.
# Note: Contents/Info.plist is where it's in 4.7.x, not sure if the location is kosher... According to
#       https://developer.apple.com/library/mac/documentation/MacOSX/Conceptual/BPFrameworks/Concepts/FrameworkAnatomy.html
#       the Info.plist file goes into Resources.
#
ifeq ($(KBUILD_TARGET),darwin)
 include $(KBUILD_PATH)/units/qt5.kmk
 INSTALLS += qt5-bin
 qt5-bin_MODE = 755
 qt5-bin_INST = $(INST_VIRTUALBOX)Contents/
 qt5-bin_SOURCES = $(foreach qtmod,$(VBOX_QT_MOD_NAMES), \
  $(PATH_SDK_QT5_LIB)/$(qtmod).framework/Versions/5/$(qtmod)=>Frameworks/$(qtmod).framework/Versions/5/$(qtmod) \
  $(PATH_SDK_QT5_LIB)/$(qtmod).framework/Versions/5/Resources/Info.plist=>Frameworks/$(qtmod).framework/Versions/5/Resources/Info.plist)
 qt5-bin_SOURCES += \
  $(PATH_SDK_QT5)/plugins/platforms/libqcocoa$(SUFF_DLL)=>plugins/platforms/libqcocoa$(SUFF_DLL) \
  $(PATH_SDK_QT5)/plugins/platforms/libqminimal$(SUFF_DLL)=>plugins/platforms/libqminimal$(SUFF_DLL) \
  $(PATH_SDK_QT5)/plugins/platforms/libqoffscreen$(SUFF_DLL)=>plugins/platforms/libqoffscreen$(SUFF_DLL)
 qt5-bin_SYMLINKS = $(foreach qtmod, $(VBOX_QT_MOD_NAMES), \
  Frameworks/$(qtmod).framework/Versions/Current=>5 \
  Frameworks/$(qtmod).framework/$(qtmod)=>Versions/5/$(qtmod) \
  Frameworks/$(qtmod).framework/Resources=>Versions/5/Resources)
else # win x11
 if1of ($(KBUILD_TARGET), linux solaris)
  ifndef VBOX_ONLY_BUILD
   ifneq ($(VBOX_GCC_VERSION_CXX),)
    ifeq ($(int-ge $(VBOX_GCC_VERSION_CXX),40400),)
     $(error gcc >= 4.4 required when compiling against Qt5!)
    endif
   endif
  endif
 endif
 if defined(VBOX_WITH_ORACLE_QT) || defined(VBOX_WITH_QT_PAYLOAD)
  include $(KBUILD_PATH)/units/qt5.kmk
  ifeq ($(KBUILD_TARGET),win)
   INSTALLS += qt5-bin
   qt5-bin_MODE = 755
   qt5-bin_INST = $(INST_BIN)
   qt5-bin_SOURCES = \
    $(foreach qtmod,$(VBOX_QT_MOD_NAMES),$(call VBOX_RE_SIGN_DLL_FN,qt5-bin,$(PATH_SDK_QT5)/bin/$(qtmod)$(SUFF_DLL)))
   qt5-bin_SOURCES += \
    $(call VBOX_RE_SIGN_DLL_FN,qt5-bin,$(PATH_SDK_QT5)/plugins/platforms/qwindows$(SUFF_DLL))=>platforms/qwindows$(SUFF_DLL) \
    $(call VBOX_RE_SIGN_DLL_FN,qt5-bin,$(PATH_SDK_QT5)/plugins/platforms/qminimal$(SUFF_DLL))=>platforms/qminimal$(SUFF_DLL) \
    $(call VBOX_RE_SIGN_DLL_FN,qt5-bin,$(PATH_SDK_QT5)/plugins/platforms/qoffscreen$(SUFF_DLL))=>platforms/qoffscreen$(SUFF_DLL)
   ifdef VBOX_WITH_QT_PDBS
    qt5-bin_SOURCES += \
     $(foreach qtmod,$(VBOX_QT_MOD_NAMES),$(wildcard $(PATH_SDK_QT5)/qt*/$(VBOX_PATH_QT_LIB)/$(qtmod).pdb))
   endif # VBOX_WITH_QT_PDBS
  else # x11
   INSTALLS += qt5-bin
   qt5-bin_MODE = 755
   qt5-bin_INST = $(INST_BIN)
   ifdef VBOX_WITH_HARDENING
    # The wildcards are necessary to install the libs instead of the symlinks
    qt5-bin_SOURCES = \
     $(foreach qtmod,$(VBOX_QT_MOD_NAMES),$(wildcard $(VBOX_PATH_QT_LIB)/lib$(qtmod).so.*.*.*)=>lib$(qtmod).so.5) \
     $(foreach lib,$(VBOX_QT_PLUGINS),$(VBOX_PATH_QT)/$(lib)=>$(lib))
     ifneq ($(KBUILD_TARGET),solaris)
      qt5-bin_SOURCES += \
       $(foreach lib,$(VBOX_QT_LEGACY_LIBS),$(wildcard $(VBOX_PATH_QT_LIB)/legacy/$(lib).*.*)=>legacy/$(lib))
     endif # solaris
   else # !VBOX_WITH_HARDENING
    # For non-hardened builds we need to remove the RUNPATH. This stuff is
    # ugly but we need to prevent kBuild from hard-linking otherwise we
    # (indirectly) change the binaries in tools
    ifneq ($(KBUILD_TARGET),solaris)
     QT5_VERSION = 5.6.1
    else
     QT5_VERSION = 5.6.2
    endif
    qt5-bin_SOURCES = \
     $(foreach qtmod,$(VBOX_QT_MOD_NAMES),$(qt5-bin_0_OUTDIR)/lib$(qtmod).so.$(QT5_VERSION)=>lib$(qtmod).so.5) \
     $(foreach lib,$(VBOX_QT_PLUGINS),$(qt5-bin_0_OUTDIR)/$(lib)=>$(lib))
     ifneq ($(KBUILD_TARGET),solaris)
      qt5-bin_SOURCES += \
       $(foreach lib,$(VBOX_QT_LEGACY_LIBS),$(qt5-bin_0_OUTDIR)/$(lib)=>legacy/$(lib))
     endif # solaris

$(foreach qtmod,$(VBOX_QT_MOD_NAMES),$$(qt5-bin_0_OUTDIR)/lib$(qtmod).so.$(QT5_VERSION)): \
	$$(qt5-bin_0_OUTDIR)/% : $(VBOX_PATH_QT_LIB)/% | $$(qt5-bin_0_OUTDIR)/
	$(call MSG_INST_FILE,$^,$@)
	$(QUIET)$(CP) $^ $@
	$(QUIET)chrpath --delete $@

     ifn1of ($(KBUILD_TARGET),solaris linux)
$(foreach lib,$(VBOX_QT_PLUGINS),$$(qt5-bin_0_OUTDIR)/$(lib)): \
	$$(qt5-bin_0_OUTDIR)/% : $(VBOX_PATH_QT)/% | $$(qt5-bin_0_OUTDIR)/
	$(call MSG_INST_FILE,$^,$@)
	$(QUIET)$(MKDIR) -p $(@D)
	$(QUIET)$(CP) $^ $@
	$(QUIET)chrpath --delete $@
     endif # !solaris and !linux

     # @todo For solaris and some linuxes dlopen fails to navigate executable rpath to dependent libraries,
     #       so add explicit rpath for libqxcb.so, find better solution later.
     if1of ($(KBUILD_TARGET),solaris linux)
$(foreach lib,$(VBOX_QT_PLUGINS),$$(qt5-bin_0_OUTDIR)/$(lib)): \
	$$(qt5-bin_0_OUTDIR)/% : $(VBOX_PATH_QT)/% | $$(qt5-bin_0_OUTDIR)/
	$(call MSG_INST_FILE,$^,$@)
	$(QUIET)$(MKDIR) -p $(@D)
	$(QUIET)$(CP) $^ $@
	$(QUIET)chrpath --replace "\$$ORIGIN/../../" $@
     endif # solaris linux

$(foreach lib,$(VBOX_QT_LEGACY_LIBS),$$(qt5-bin_0_OUTDIR)/$(lib)): \
	$$(qt5-bin_0_OUTDIR)/% : $(VBOX_PATH_QT_LIB)/legacy/% | $$(qt5-bin_0_OUTDIR)/
	$(call MSG_INST_FILE,$^,$@)
	$(QUIET)$(CP) $^ $@
	$(QUIET)chrpath --delete $@

   endif # !VBOX_WITH_HARDENING
  endif # x11
 endif # VBOX_WITH_ORACLE_QT || VBOX_WITH_QT_PAYLOAD
endif # win x11


#
# Install additions iso from the build server if configured to do so.
#
# Note! For building the combined package, just get the additions .ISO
#       once for amd64 to prevent version inconsistences. In all other
#       cases we get the .ISO per target architecture.
#
if  defined(VBOX_WITH_ADDITIONS_FROM_BUILD_SERVER) \
 && (   !defined(VBOX_WITH_COMBINED_PACKAGE) \
     || "$(KBUILD_TARGET_ARCH)" == "amd64" )
 INSTALLS += buildserver-additions
 buildserver-additions_INST = $(INST_ADDITIONS_ISO)
 buildserver-additions_MODE = 0644
 buildserver-additions_SOURCES = $(PATH_TARGET)/VBoxGuestAdditions.iso
 buildserver-additions_CLEANS = \
        $(buildserver-additions_0_OUTDIR)/unpacked.ts \
        $(buildserver-additions_0_OUTDIR)/VBoxGuestAdditions.zip \
        $(buildserver-additions_0_OUTDIR)/VBoxGuestAdditions.zip.tmp \
        $(PATH_TARGET)/VBoxGuestAdditions.iso

 $$(buildserver-additions_0_OUTDIR)/unpacked.ts +| $(PATH_TARGET)/VBoxGuestAdditions.iso: \
 		$$(buildserver-additions_0_OUTDIR)/VBoxGuestAdditions.zip
	$(call MSG_L1,Unpacking additions archive)
	$(QUIET)$(TOOL_ZIP_UNPACK) $(TOOL_ZIP_UNPACKFLAGS) -o $< -d $(PATH_TARGET)
	$(TOUCH) -c -- $(PATH_TARGET)/VBoxGuestAdditions.iso
	$(APPEND) -t $@ "done"

 $$(buildserver-additions_0_OUTDIR)/VBoxGuestAdditions.zip: $(VBOX_SVN_REV_KMK) $(PATH_DEVTOOLS)/bin/additions.sh | $$(dir $$@)
	$(RM) -f -- "$@" "$@.tmp"
	$(SHELL) $(PATH_DEVTOOLS)/bin/additions.sh --cmd fetch --filename "$@.tmp" $(if $(VBOX_USE_PROXY_FOR_BUILD_SERVER),--default-proxy,)
	$(MV) -f -- "$@.tmp" "$@"

endif # VBOX_WITH_ADDITIONS_FROM_BUILD_SERVER unless win.x86+combined


#
# Install documentation files (at the moment the .chm) from the build server.
#
ifdef VBOX_WITH_DOCS_FROM_BUILD_SERVER
## @todo r=bird: Too much mess now for $(PATH_TARGET); move to doc/manual/.
INSTALLS += buildserver-docs
buildserver-docs_INST = $(INST_BIN)
buildserver-docs_MODE = 0644
buildserver-docs_SOURCES = \
	$(addprefix $(PATH_TARGET)/, \
		VirtualBox.chm UserManual.pdf \
		$(foreach f,$(VBOX_MANUAL_ADD_LANGUAGES),VirtualBox_$(f).chm UserManual_$(f).pdf))
buildserver-docs_CLEANS = \
	$(buildserver-docs_0_OUTDIR)/unpacked.ts \
	$(buildserver-docs_0_OUTDIR)/VBoxDocumentation.zip \
	$(buildserver-docs_0_OUTDIR)/VBoxDocumentation.zip.tmp \
	$(addprefix $(PATH_TARGET)/, \
		VirtualBox.chm UserManual.pdf \
		$(foreach f,$(VBOX_MANUAL_ADD_LANGUAGES),VirtualBox_$(f).chm UserManual_$(f).pdf))

$$(buildserver-docs_0_OUTDIR)/unpacked.ts +| $(PATH_TARGET)/VirtualBox.chm $(PATH_TARGET)/UserManual.pdf \
$(foreach f,$(VBOX_MANUAL_ADD_LANGUAGES),$(PATH_TARGET)/VirtualBox_$(f).chm $(PATH_TARGET)/UserManual_$(f).pdf): \
		$$(buildserver-docs_0_OUTDIR)/VBoxDocumentation.zip
	$(call MSG_L1,Unpacking documentation)
	$(QUIET)$(TOOL_ZIP_UNPACK) $(TOOL_ZIP_UNPACKFLAGS) -o $< -d $(PATH_TARGET)
	$(TOUCH) -c -- $(PATH_TARGET)/VirtualBox.chm \
		$(PATH_TARGET)/UserManual.pdf \
		$(foreach f,$(VBOX_MANUAL_ADD_LANGUAGES),$(PATH_TARGET)/VirtualBox_$(f).chm $(PATH_TARGET)/UserManual_$(f).pdf)
	$(APPEND) -t $@ "done"

$$(buildserver-docs_0_OUTDIR)/VBoxDocumentation.zip: $(VBOX_SVN_REV_KMK) $(PATH_DEVTOOLS)/bin/documentation.sh | $$(dir $$@)
	$(RM) -f -- "$@" "$@.tmp"
	$(SHELL) $(PATH_DEVTOOLS)/bin/documentation.sh --cmd fetch --filename "$@.tmp" $(if $(VBOX_USE_PROXY_FOR_BUILD_SERVER),--default-proxy,)
	$(MV) -f -- "$@.tmp" "$@"

endif # VBOX_WITH_DOCS_FROM_BUILD_SERVER


 ifdef VBOX_WITH_EFI
  #
  # Install EFI firmware image
  #
  ifdef VBOX_WITH_EFIFW_FROM_BUILD_SERVER
   #
   # Either from the build server.
   #
   ifndef VBOX_EFI_FIRMWARE_EFI_MODULES_KMK_INCLUDED
    include $(PATH_ROOT)/src/VBox/Devices/EFI/Firmware/EfiModules.kmk
   endif
   INSTALLS += buildserver-efifw
   buildserver-efifw_INST = $(INST_BIN)
   buildserver-efifw_MODE = 0644
   buildserver-efifw_SOURCES = \
   	$(buildserver-efifw_0_OUTDIR)/VBoxEFI32.fd \
   	$(buildserver-efifw_0_OUTDIR)/VBoxEFI64.fd
   buildserver-efifw_CLEANS = \
   	$(buildserver-efifw_0_OUTDIR)/unpacked.ts \
   	$(buildserver-efifw_0_OUTDIR)/VBoxEFI32.fd \
   	$(buildserver-efifw_0_OUTDIR)/VBoxEFI64.fd \
   	$(buildserver-efifw_0_OUTDIR)/VBoxEfiFirmware.zip \
   	$(buildserver-efifw_0_OUTDIR)/VBoxEfiFirmware.zip.tmp \
   	$(foreach arch, amd64 x86, $(foreach mod,$(VBOX_EFI_MODULES_FLAT),$$(buildserver-efifw_0_OUTDIR)/$(arch)/$(mod).pdb))

   INSTALLS += buildserver-efifw-dbg-amd64
   buildserver-efifw-dbg-amd64_INST = $(INST_VBOXDBG_SYMS)amd64/
   buildserver-efifw-dbg-amd64_MODE = 0644
   buildserver-efifw-dbg-amd64_SOURCES = \
   	$(foreach mod,$(VBOX_EFI_MODULES_FLAT),$(buildserver-efifw_0_OUTDIR)/amd64/$(mod).pdb)

   INSTALLS += buildserver-efifw-dbg-x86
   buildserver-efifw-dbg-x86_INST = $(INST_VBOXDBG_SYMS)x86/
   buildserver-efifw-dbg-x86_MODE = 0644
   buildserver-efifw-dbg-x86_SOURCES = \
   	$(foreach mod,$(VBOX_EFI_MODULES_FLAT),$(buildserver-efifw_0_OUTDIR)/x86/$(mod).pdb)

   $$(buildserver-efifw_0_OUTDIR)/unpacked.ts \
   +| $$(buildserver-efifw_0_OUTDIR)/VBoxEFI32.fd \
      $$(buildserver-efifw_0_OUTDIR)/VBoxEFI64.fd \
      $(foreach arch, amd64 x86, $(foreach mod,$(VBOX_EFI_MODULES_FLAT),$$(buildserver-efifw_0_OUTDIR)/$(arch)/$(mod).pdb)): \
   		$$(buildserver-efifw_0_OUTDIR)/VBoxEfiFirmware.zip
	$(call MSG_L1,Unpacking EFI firmware)
	$(QUIET)$(TOOL_ZIP_UNPACK) $(TOOL_ZIP_UNPACKFLAGS) -o $< -d $(buildserver-efifw_0_OUTDIR)
	$(foreach arch, amd64 x86, \
		$(NLTAB) $(QUIET)$(TEST) '!' -d $(dir $@)/$(arch) -- $(MKDIR_EXT) -- $(dir $@)/$(arch) \
		$(foreach mod,$(VBOX_EFI_MODULES_FLAT) \
		,$(NLTAB) $(QUIET)$(TEST) '!' -f $(dir $@)/$(arch)/$(mod).pdb -- $(APPEND_EXT) $(dir $@)/$(arch)/$(mod).pdb ))
	$(TOUCH) -c -- $(buildserver-efifw_0_OUTDIR)/VBoxEFI32.fd \
		$(buildserver-efifw_0_OUTDIR)/VBoxEFI64.fd
	$(APPEND) -t $@ "done"

   $$(buildserver-efifw_0_OUTDIR)/VBoxEfiFirmware.zip: \
		$(VBOX_SVN_REV_KMK) $(PATH_DEVTOOLS)/bin/efi_firmware.sh | $$(dir $$@)
	$(RM) -f -- "$@" "$@.tmp"
	$(SHELL) $(PATH_DEVTOOLS)/bin/efi_firmware.sh --cmd fetch --filename "$@.tmp" $(if $(VBOX_USE_PROXY_FOR_BUILD_SERVER),--default-proxy,)
	$(MV) -f -- "$@.tmp" "$@"

  else # !VBOX_WITH_EFIFW_FROM_BUILD_SERVER
   #
   # Or from the local copy (no debug).
   #
   INSTALLS += local-efifw
   local-efifw_INST = $(INST_BIN)
   local-efifw_MODE = 0644
   local-efifw_SOURCES = \
   	$(PATH_ROOT)/src/VBox/Devices/EFI/FirmwareBin/VBoxEFI32.fd=>VBoxEFI32.fd \
   	$(PATH_ROOT)/src/VBox/Devices/EFI/FirmwareBin/VBoxEFI64.fd=>VBoxEFI64.fd
  endif # !VBOX_WITH_EFIFW_FROM_BUILD_SERVER
 endif # VBOX_WITH_EFI


ifdef VBOX_WITH_EXTPACKS_FROM_BUILD_SERVER
#
# Get the extension pack from from the build server to facility the automatic
# testing (everything in one tarball (VBoxAll-*)).
#
# Note! Using the plural here as we might be downloading more packages eventually.
#
INSTALLS += buildserver-extpacks
buildserver-extpacks_INST = $(INST_DIST)
buildserver-extpacks_MODE = 0644
buildserver-extpacks_SOURCES = \
	$(buildserver-extpacks_0_OUTDIR)/Oracle_VM_VirtualBox_Extension_Pack.vbox-extpack
buildserver-extpacks_CLEANS = \
	$(buildserver-extpacks_0_OUTDIR)/Oracle_VM_VirtualBox_Extension_Pack.vbox-extpack \
	$(buildserver-extpacks_0_OUTDIR)/Oracle_VM_VirtualBox_Extension_Pack.vbox-extpack.tmp

$$(buildserver-extpacks_0_OUTDIR)/Oracle_VM_VirtualBox_Extension_Pack.vbox-extpack: \
		$(VBOX_SVN_REV_KMK) $(PATH_DEVTOOLS)/bin/extpacks.sh | $$(dir $$@)
	$(RM) -f -- "$@.tmp" "$@"
	$(SHELL) $(PATH_DEVTOOLS)/bin/extpacks.sh --cmd fetch --filename "$@.tmp" --vbox-version "$(VBOX_VERSION_STRING_NO_PUB)" \
		$(if $(VBOX_USE_PROXY_FOR_BUILD_SERVER),--default-proxy,)
	$(MV) -f -- "$@.tmp" "$@"
	$(TOUCH) -- "$@"

endif


#
# Install staged binaries on platforms where we can't cross
# compile things.
#
ifn1of ($(KBUILD_TARGET), linux win)
 VBOX_PATH_STAGED ?= .

 # Additions.
 ifndef VBOX_WITH_LINUX_ADDITIONS
  ifndef VBOX_WITH_WIN32_ADDITIONS
   ifneq ($(wildcard $(VBOX_PATH_STAGED)/VBoxGuestAdditions.iso),)
    INSTALLS += staged-additions
    staged-additions_INST = $(INST_ADDITIONS_ISO)
    staged-additions_MODE = 0644
    staged-additions_SOURCES = $(VBOX_PATH_STAGED)/VBoxGuestAdditions.iso
   endif
  endif
 endif

 # guesttool.exe
 ifndef VBOX_WITH_WIN32_ADDITIONS
  ifneq ($(wildcard $(VBOX_PATH_STAGED)/guesttool.exe),)
   INSTALLS += staged-guesttool
   staged-guesttool_INST = $(INST_BIN)
   staged-guesttool_SOURCES = $(VBOX_PATH_STAGED)/guesttool.exe
  endif
 endif

endif

endif # !VBOX_ONLY_ADDITIONS && !VBOX_ONLY_DOCS && !VBOX_ONLY_EXTPACKS && !VBOX_ONLY_VALIDATIONKIT


ifdef VBOX_ONLY_DOCS
# It may sound a bit odd, but for preparing the documentation package the
# doxygen documentation isn't needed and increases the build time a lot.
docs:
else  # !VBOX_ONLY_DOCS
#
# Generate documentation.
# (This should be converted into a separate pass or merged with an existing one later.)
#
 ifdef VBOX_WITH_ALL_DOXYGEN_TARGETS
docs: docs.Core
 endif
endif # !VBOX_ONLY_DOCS

#
# The core (VMM+REM+Devices+Main) documentation.
#
# This includes so much because we wish to have the complete CFGM
# and GCFGM lists.
#
VBOX_CORE_DOXYFILE_OUTPUT = $(PATH_OUT)/docs/Core
BLDDIRS += $(VBOX_CORE_DOXYFILE_OUTPUT)
OTHER_CLEAN += \
	$(VBOX_CORE_DOXYFILE_OUTPUT)/Doxyfile.Core \
	$(VBOX_CORE_DOXYFILE_OUTPUT)/Doxyfile.Core.dep

VBOX_CORE_DOXYFILE_INPUT_DIRS = \
	include/iprt \
	include/iprt/cpp \
	include/iprt/crypto \
	include/iprt/formats \
	include/iprt/linux \
	include/iprt/nt \
	include/iprt/solaris \
	include/iprt/win \
	include/iprt/nocrt \
	include/VBox \
	include/VBox/vmm \
	include/VBox/com \
	include/VBox/ExtPack \
	include/VBox/HostServices \
	include/VBox/GuestHost \
	include/VBox/HGSMI \
	src/VBox/VMM \
	src/VBox/VMM/VMMR0 \
	src/VBox/VMM/VMMRC \
	src/VBox/VMM/VMMR3 \
	src/VBox/VMM/VMMAll \
	src/VBox/VMM/VMMSwitcher \
	src/VBox/VMM/include \
	src/VBox/Debugger \
	src/VBox/Devices \
	src/VBox/Devices/Audio \
	src/VBox/Devices/Bus \
	src/VBox/Devices/Graphics \
	src/VBox/Devices/Graphics/BIOS \
	src/VBox/Devices/Graphics/shaderlib \
	src/VBox/Devices/Input \
	src/VBox/Devices/Networking \
	src/VBox/Devices/PC \
	src/VBox/Devices/PC/BIOS \
	src/VBox/Devices/Parallel \
	src/VBox/Devices/Serial \
	src/VBox/Devices/Storage \
	src/VBox/Devices/USB \
	src/VBox/Devices/USB/darwin \
	src/VBox/Devices/USB/linux \
	src/VBox/Devices/USB/os2 \
	src/VBox/Devices/USB/solaris \
	src/VBox/Devices/USB/vrdp \
	src/VBox/Devices/USB/win32 \
	src/VBox/Devices/VMMDev \
	src/VBox/Main/include \
	src/VBox/Main/include/hgcm \
	src/VBox/Main \
	src/VBox/Main/glue \
	src/VBox/Main/webservice \
	src/VBox/Main/xml \
	src/VBox/Main/src-all \
	src/VBox/Main/src-all/win \
	src/VBox/Main/src-client \
	src/VBox/Main/src-client/win \
	src/VBox/Main/src-client/xpcom \
	src/VBox/Main/src-server \
	src/VBox/Main/src-server/darwin \
	src/VBox/Main/src-server/linux \
	src/VBox/Main/src-server/os2 \
	src/VBox/Main/src-server/solaris \
	src/VBox/Main/src-server/win \
	src/VBox/Main/src-server/xpcom \
	src/VBox/HostServices \
	src/VBox/HostServices/DragAndDrop \
	src/VBox/HostServices/GuestControl \
	src/VBox/HostServices/GuestProperties \
	src/VBox/HostServices/SharedClipboard \
	src/VBox/HostServices/SharedFolders \
	src/VBox/HostServices/SharedOpenGL \
	src/VBox/HostServices/SharedOpenGL/crserver \
	src/VBox/HostServices/SharedOpenGL/crserverlib \
	src/VBox/HostServices/SharedOpenGL/render \
	src/VBox/HostServices/SharedOpenGL/unpacker \
	src/VBox/HostServices/auth \
	src/VBox/HostServices/auth/directoryservice \
	src/VBox/HostServices/auth/pam \
	src/VBox/HostServices/auth/simple \
	src/VBox/HostServices/auth/winlogon \
	src/VBox/HostDrivers/Support \
	src/VBox/HostDrivers/Support/darwin \
	src/VBox/HostDrivers/Support/freebsd \
	src/VBox/HostDrivers/Support/linux \
	src/VBox/HostDrivers/Support/os2 \
	src/VBox/HostDrivers/Support/solaris \
	src/VBox/HostDrivers/Support/win \
	src/VBox/HostDrivers/VBoxNetFlt \
	src/VBox/HostDrivers/VBoxNetFlt/darwin \
	src/VBox/HostDrivers/VBoxNetFlt/linux \
	src/VBox/HostDrivers/VBoxNetFlt/solaris \
	src/VBox/HostDrivers/VBoxNetFlt/win \
	src/VBox/HostDrivers/VBoxNetNat \
	src/VBox/HostDrivers/VBoxNetNat/darwin \
	src/VBox/HostDrivers/VBoxNetNat/linux \
	src/VBox/HostDrivers/VBoxNetNat/solaris \
	src/VBox/HostDrivers/VBoxNetNat/win \
	src/VBox/HostDrivers/VBoxNetAdp \
	src/VBox/HostDrivers/VBoxNetAdp/darwin \
	src/VBox/HostDrivers/VBoxNetAdp/linux \
	src/VBox/HostDrivers/VBoxNetAdp/solaris \
	src/VBox/HostDrivers/VBoxNetAdp/win \
	src/VBox/HostDrivers/VBoxPci \
	src/VBox/HostDrivers/VBoxPci/darwin \
	src/VBox/HostDrivers/VBoxPci/linux \
	src/VBox/HostDrivers/VBoxPci/solaris \
	src/VBox/HostDrivers/VBoxPci/win \
	src/VBox/HostDrivers/VBoxUSB \
	src/VBox/HostDrivers/VBoxUSB/darwin \
	src/VBox/HostDrivers/VBoxUSB/os2 \
	src/VBox/HostDrivers/VBoxUSB/solaris \
	src/VBox/HostDrivers/VBoxUSB/win \
	src/VBox/HostDrivers/VBoxUSB/win/Device \
	src/VBox/HostDrivers/VBoxUSB/win/Device/amd64 \
	src/VBox/HostDrivers/VBoxUSB/win/Device/x86 \
	src/VBox/HostDrivers/VBoxUSB/win/Filter \
	src/VBox/HostDrivers/VBoxUSB/win/Install \
	src/VBox/HostDrivers/VBoxUSB/win/Monitor \
	src/VBox/HostDrivers/VBoxUSB/win/Monitor/win32 \
	src/VBox/HostDrivers/VBoxUSB/win/Monitor/win64 \
	src/VBox/HostDrivers/VBoxUSB/win/usbd \
	src/VBox/Additions \
	src/VBox/Additions/WINNT \
	src/VBox/Additions/WINNT/Graphics \
	src/VBox/Additions/WINNT/Graphics/Video \
	src/VBox/Additions/WINNT/Graphics/Video/common \
	src/VBox/Additions/WINNT/Graphics/Video/common/wddm \
	src/VBox/Additions/WINNT/Graphics/Video/common/xpdm \
	src/VBox/Additions/WINNT/Graphics/Video/disp \
	src/VBox/Additions/WINNT/Graphics/Video/disp/common \
	src/VBox/Additions/WINNT/Graphics/Video/disp/wddm \
	src/VBox/Additions/WINNT/Graphics/Video/disp/wddm/dbg \
	src/VBox/Additions/WINNT/Graphics/Video/disp/xpdm \
	src/VBox/Additions/WINNT/Graphics/Video/mp \
	src/VBox/Additions/WINNT/Graphics/Video/mp/common \
	src/VBox/Additions/WINNT/Graphics/Video/mp/wddm \
	src/VBox/Additions/WINNT/Graphics/Video/mp/xpdm \
	src/VBox/Additions/WINNT/Graphics/Wine_new \
	src/VBox/Additions/WINNT/Graphics/Wine_new/d3d8 \
	src/VBox/Additions/WINNT/Graphics/Wine_new/d3d9 \
	src/VBox/Additions/WINNT/Graphics/Wine_new/libWine \
	src/VBox/Additions/WINNT/Graphics/Wine_new/switcher \
	src/VBox/Additions/WINNT/Graphics/Wine_new/vbox \
	src/VBox/Additions/WINNT/Graphics/Wine_new/wined3d \
	src/VBox/Additions/WINNT/Installer \
	src/VBox/Additions/WINNT/Installer/ISO \
	src/VBox/Additions/WINNT/Installer/InstallHelper \
	src/VBox/Additions/WINNT/Installer/Languages \
	src/VBox/Additions/WINNT/Installer/Loader \
	src/VBox/Additions/WINNT/Mouse \
	src/VBox/Additions/WINNT/Mouse/NT5 \
	src/VBox/Additions/WINNT/Mouse/common \
	src/VBox/Additions/WINNT/SharedFolders \
	src/VBox/Additions/WINNT/SharedFolders/redirector \
	src/VBox/Additions/WINNT/SharedFolders/redirector/dll \
	src/VBox/Additions/WINNT/SharedFolders/redirector/sys \
	src/VBox/Additions/WINNT/SharedFolders/redirector/sys/rdbss \
	src/VBox/Additions/WINNT/VBoxCredProv \
	src/VBox/Additions/WINNT/VBoxGINA \
	src/VBox/Additions/WINNT/VBoxHook \
	src/VBox/Additions/WINNT/VBoxTray \
	src/VBox/Additions/WINNT/VBoxUSB \
	src/VBox/Additions/WINNT/i8042prt \
	src/VBox/Additions/WINNT/i8042prt/i386 \
	src/VBox/Additions/WINNT/i8042prt/include \
	src/VBox/Additions/WINNT/include \
	src/VBox/Additions/common \
	src/VBox/Additions/common/VBoxControl \
	src/VBox/Additions/common/VBoxGuest \
	src/VBox/Additions/common/VBoxGuest/freebsd \
	src/VBox/Additions/common/VBoxGuest/linux \
	src/VBox/Additions/common/VBoxGuest/win \
	src/VBox/Additions/common/VBoxGuestLib \
	src/VBox/Additions/common/VBoxService \
	src/VBox/Additions/common/VBoxVideo \
	src/VBox/Additions/common/crOpenGL \
	src/VBox/Additions/common/crOpenGL/array \
	src/VBox/Additions/common/crOpenGL/feedback \
	src/VBox/Additions/common/crOpenGL/pack \
	src/VBox/Additions/common/crOpenGL/passthrough \
	src/VBox/Additions/common/pam \
	src/VBox/Additions/darwin \
	src/VBox/Additions/freebsd \
	src/VBox/Additions/freebsd/Installer \
	src/VBox/Additions/freebsd/drm \
	src/VBox/Additions/freebsd/vboxvfs \
	src/VBox/Additions/linux \
	src/VBox/Additions/linux/drm \
	src/VBox/Additions/linux/installer \
	src/VBox/Additions/linux/selinux-fedora \
	src/VBox/Additions/linux/sharedfolders \
	src/VBox/Additions/os2 \
	src/VBox/Additions/os2/VBoxGradd \
	src/VBox/Additions/os2/VBoxGradd/graddlib \
	src/VBox/Additions/os2/VBoxGrext \
	src/VBox/Additions/os2/VBoxMouse \
	src/VBox/Additions/os2/VBoxSF \
	src/VBox/Additions/solaris \
	src/VBox/Additions/solaris/DRM \
	src/VBox/Additions/solaris/Installer \
	src/VBox/Additions/solaris/SharedFolders \
	src/VBox/Additions/solaris/SharedFolders/solaris10 \
	src/VBox/Additions/solaris/SharedFolders/solaris10/sys \
	src/VBox/Additions/solaris/Virtio \
	src/VBox/Additions/x11 \
	src/VBox/Additions/x11/Installer \
	src/VBox/Additions/x11/VBoxClient \
	src/VBox/Additions/x11/vboxmouse \
	src/VBox/Additions/x11/vboxmouse/xorg70 \
	src/VBox/Additions/x11/vboxmouse/xorg71 \
	src/VBox/Additions/x11/vboxvideo \
	src/VBox/NetworkServices \
	src/VBox/NetworkServices/DHCP \
	src/VBox/NetworkServices/NAT \
	src/VBox/NetworkServices/NetLib \
	src/VBox/Storage \
	src/VBox/ValidationKit/ \
	src/VBox/ValidationKit/docs/ \
	src/VBox/ValidationKit/testdriver/ \
	src/VBox/ValidationKit/bootsectors/ \
	src/VBox/ValidationKit/bootsectors/bs3kit/ \
	src/VBox/ValidationKit/tests/ \
	src/VBox/ValidationKit/tests/additions/ \
	src/VBox/ValidationKit/tests/api/ \
	src/VBox/ValidationKit/tests/autostart/ \
	src/VBox/ValidationKit/tests/benchmarks/ \
	src/VBox/ValidationKit/tests/cpu/ \
	src/VBox/ValidationKit/tests/installation/ \
	src/VBox/ValidationKit/tests/network/ \
	src/VBox/ValidationKit/tests/selftests/ \
	src/VBox/ValidationKit/tests/smoketests/ \
	src/VBox/ValidationKit/tests/storage/ \
	src/VBox/ValidationKit/tests/teleportation/ \
	src/VBox/ValidationKit/tests/unittests/ \
	src/VBox/ValidationKit/tests/usb/ \
	src/VBox/ValidationKit/common/ \
	src/VBox/ValidationKit/utils/ \
	src/VBox/ValidationKit/utils/TestExecServ/ \
	src/VBox/ValidationKit/utils/cpu/ \
	src/VBox/ValidationKit/utils/misc/ \
	src/VBox/ValidationKit/utils/network/ \
	src/VBox/ValidationKit/utils/nt/ \
	src/VBox/ValidationKit/utils/usb/ \
	src/VBox/ValidationKit/vms/ \
	src/VBox/ValidationKit/testmanager/ \
	src/VBox/ValidationKit/testmanager/core/ \
	src/VBox/ValidationKit/testmanager/db/ \
	src/VBox/ValidationKit/testmanager/debug/ \
	src/VBox/ValidationKit/testmanager/cgi/ \
	src/VBox/ValidationKit/testmanager/webui/ \
	src/VBox/ValidationKit/testboxscript/ \

# These must come first in order to make things look nice.
VBOX_CORE_DOXYFILE_INPUT_FIRST =\
	$(PATH_ROOT)/doc/VBox-doc.c \
	$(PATH_ROOT)/doc/VBox-CodingGuidelines.cpp \
	$(PATH_ROOT)/doc/VBox-MakefileGuidelines.cpp \
	$(PATH_ROOT)/src/VBox/VMM/Docs-CodingGuidelines.cpp \
	$(PATH_ROOT)/src/VBox/VMM/Docs-RawMode.cpp \
	$(PATH_ROOT)/include/VBox/cdefs.h \
	$(PATH_ROOT)/include/VBox/vmm/vmm.h \
	$(PATH_ROOT)/include/VBox/vmm/vmapi.h \
	$(PATH_ROOT)/include/VBox/vmm/cpum.h \
	$(PATH_ROOT)/include/VBox/vmm/mm.h \
	$(PATH_ROOT)/include/VBox/vmm/pgm.h \
	$(PATH_ROOT)/include/VBox/vmm/selm.h \
	$(PATH_ROOT)/include/VBox/vmm/trpm.h \
	$(PATH_ROOT)/include/VBox/vmm/patm.h \
	$(PATH_ROOT)/include/VBox/vmm/dbgf.h \
	$(PATH_ROOT)/include/VBox/vmm/stam.h \
	$(PATH_ROOT)/include/VBox/vmm/em.h \
	$(PATH_ROOT)/include/VBox/vmm/hm.h \
	$(PATH_ROOT)/include/VBox/vmm/hm_svm.h \
	$(PATH_ROOT)/include/VBox/vmm/hm_vmx.h \
	$(PATH_ROOT)/include/VBox/vmm/iem.h \
	$(PATH_ROOT)/include/VBox/vmm/nem.h \
	$(PATH_ROOT)/include/VBox/vmm/pdm.h \
	$(PATH_ROOT)/include/VBox/vmm/pdmifs.h \
	$(PATH_ROOT)/include/VBox/vmm/pdmaudioifs.h \
	$(PATH_ROOT)/include/VBox/vmm/pdmnetifs.h \
	$(PATH_ROOT)/include/VBox/vmm/pdmserialifs.h \
	$(PATH_ROOT)/include/VBox/vmm/pdmstorageifs.h \
	$(PATH_ROOT)/include/VBox/vmm/rem.h \
	$(PATH_ROOT)/include/VBox/vmm/iom.h \
	$(PATH_ROOT)/include/VBox/vmm/cfgm.h \
	$(PATH_ROOT)/include/VBox/vmm/gim.h \
	$(PATH_ROOT)/include/VBox/vmm/tm.h \
	$(PATH_ROOT)/include/VBox/vmm/csam.h \
	$(PATH_ROOT)/include/VBox/vmm/ssm.h \
	\
	$(PATH_ROOT)/src/VBox/VMM/include/CFGMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/CPUMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/DBGFInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/EMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/HMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/IEMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/IOMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/MMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/NEMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/PDMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/PGMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/GIMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/CSAMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/PATMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/REMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/SELMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/SSMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/STAMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/TMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/TRPMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/VMInternal.h \
	$(PATH_ROOT)/src/VBox/VMM/include/VMMInternal.h \
	\
	$(PATH_ROOT)/include/VBox/vmm/vm.h \
	\
	$(PATH_ROOT)/include/VBox/sup.h \
	$(PATH_ROOT)/include/VBox/vd.h \
	$(PATH_ROOT)/include/VBox/types.h \
	$(PATH_ROOT)/include/VBox/err.h \
	$(PATH_ROOT)/include/VBox/vmm/cpumdis.h \
	$(PATH_ROOT)/include/VBox/dbggui.h \
	$(PATH_ROOT)/include/VBox/dis.h \
	$(PATH_ROOT)/include/VBox/disopcode.h \
	$(PATH_ROOT)/include/VBox/intnet.h \
	$(PATH_ROOT)/include/VBox/settings.h \
	$(PATH_ROOT)/include/VBox/pci.h \
	$(PATH_ROOT)/include/VBox/scsi.h \
	$(PATH_ROOT)/include/VBox/shflsvc.h \
	$(PATH_ROOT)/include/VBox/hgcmsvc.h \
	$(PATH_ROOT)/include/VBox/usb.h \
	$(PATH_ROOT)/include/VBox/vusb.h \
	\
	$(PATH_ROOT)/include/VBox/log.h \
	$(PATH_ROOT)/include/VBox/param.h \
	$(PATH_ROOT)/include/VBox/version.h \
       \
	$(PATH_ROOT)/include/VBox/com/com.h

VBOX_CORE_DOXYFILE_INPUT := \
	$(filter-out %.cpp.h, $(sort $(wildcard $(addsuffix /*.h, $(VBOX_CORE_DOXYFILE_INPUT_DIRS)))) ) \
	$(foreach dir, $(VBOX_CORE_DOXYFILE_INPUT_DIRS) \
		, $(wildcard $(dir)/*.cpp $(dir)/*.c $(dir)/*.m $(dir)/*.mm $(dir)/*.py $(dir)/.asm))
VBOX_CORE_DOXYFILE_INPUT := \
	$(VBOX_CORE_DOXYFILE_INPUT_FIRST) \
	$(sort $(filter-out $(VBOX_CORE_DOXYFILE_INPUT_FIRST), $(VBOX_CORE_DOXYFILE_INPUT)))

# And some some additional stuff.
VBOX_CORE_DOXYFILE_INPUT += \
	$(PATH_ROOT)/src/recompiler/VBoxRecompiler.c \
	$(PATH_ROOT)/src/recompiler/VBoxREMWrapper.cpp

includedep $(VBOX_CORE_DOXYFILE_OUTPUT)/Doxyfile.Core.dep

# Generate the Doxyfile
$(VBOX_CORE_DOXYFILE_OUTPUT)/Doxyfile.Core: Doxyfile.Core \
		$(comp-vars VBOX_CORE_DOXYFILE_INPUT,DOXYGEN_CORE_INPUT_PREV,FORCE) \
		$(comp-vars VBOX_CORE_DOXYFILE_OUTPUT,DOXYGEN_CORE_OUTPUT_PREV,FORCE) \
		| $$(dir $$@)
	$(QUIET)$(RM) -f $@ $@.tmp $@.dep
	$(QUIET)$(CP) -f Doxyfile.Core $@.tmp
	$(QUIET)$(APPEND) $@.tmp
	$(QUIET)$(APPEND) $@.tmp "OUTPUT_DIRECTORY = $(VBOX_CORE_DOXYFILE_OUTPUT)"
	$(QUIET)$(APPEND) $@.tmp "WARN_LOGFILE = $(VBOX_CORE_DOXYFILE_OUTPUT)/errors"
	$(QUIET)$(APPEND) $@.tmp "INCLUDE_PATH = $(PATH_ROOT)/include $(PATH_ROOT)/src/VBox/VMM $(PATH_ROOT)/src/VBox/Main/include "
	$(QUIET)$(APPEND) $@.tmp "INCLUDE_FILE_PATTERNS = *.cpp.h"
	$(QUIET)$(APPEND) $@.tmp "EXCLUDE = " \
		"$(PATH_ROOT)/src/VBox/Additions/common/crOpenGL/utils.c" \
		"$(PATH_ROOT)/src/VBox/HostServices/SharedOpenGL/crserver/main.c" \
		"$(PATH_ROOT)/src/VBox/HostServices/SharedOpenGL/crserverlib/server_main.c" \
		"$(PATH_ROOT)/src/VBox/HostServices/SharedOpenGL/unpacker/unpack_arrays.c" \
		"$(PATH_ROOT)/src/VBox/Additions/common/crOpenGL/context.c"
	$(QUIET)$(APPEND) $@.tmp
	$(QUIET)$(APPEND) $@.tmp 'INPUT = $(foreach x,$(VBOX_CORE_DOXYFILE_INPUT),\$(NLTAB)$(x))'
	$(QUIET)$(APPEND) $@.tmp
	$(QUIET)$(APPEND) $@.tmp "PREDEFINED += $(DEFS) $(DEFS.$(KBUILD_TARGET)) $(DEFS.$(KBUILD_TARGET_ARCH)) $(ARCH_BITS_DEFS)"
	$(QUIET)$(APPEND) $@.tmp "PREDEFINED += ARCH_BITS=HC_ARCH_BITS R3_ARCH_BITS=HC_ARCH_BITS R0_ARCH_BITS=HC_ARCH_BITS "
	$(QUIET)$(APPEND) $@.tmp
	$(QUIET)$(MV) -f $@.tmp $@
	@$(APPEND) $@.dep "DOXYGEN_CORE_OUTPUT_PREV = $(VBOX_CORE_DOXYFILE_OUTPUT)"
	@$(APPEND) $@.dep "DOXYGEN_CORE_INPUT_PREV = $(VBOX_CORE_DOXYFILE_INPUT)"

# Do the actual job.
$(VBOX_CORE_DOXYFILE_OUTPUT)/docs.Core: $(VBOX_CORE_DOXYFILE_OUTPUT)/Doxyfile.Core $$(VBOX_CORE_DOXYFILE_INPUT) \
		| $(VBOX_CORE_DOXYFILE_OUTPUT)/
	$(QUIET)$(RM) -f $@
	$(QUIET)$(RM) -Rf $(VBOX_CORE_DOXYFILE_OUTPUT)/html/
	doxygen $(VBOX_CORE_DOXYFILE_OUTPUT)/Doxyfile.Core
	$(SED) -n \
               -e ':nextwarning' \
               -e '/^ *$(DOLLAR)/d' \
               -e '/\/src\/VBox\/Main\/.* warning: documented symbol.*::~.* was not declared or defined/b ignore' \
               -e '/\/src\/VBox\/Main\/.* warning: explicit link request to.* could not be resolved/b ignore' \
               -e '/\/src\/VBox\/Additions\/common\/crOpenGL\/.* warning/b ignore' \
               -e '/\/src\/VBox\/Additions\/x11\/VBoxClient\/seamless-x11\.h.* warning/b ignore' \
               -e '/\/src\/VBox\/HostDrivers\/Support\/win\/SUPR3HardenedMain-win\.cpp.* warning/b ignore' \
               -e '/\/src\/VBox\/ValidationKit\/.* warning/b ignore' \
               \
               -e '/unable to resolve link to .dtrace_pops_t./b ignore' \
               \
               -e 'b end' \
               -e ':ignore' \
               -e 'n' \
               -e '/^[[:space:]]/b ignore' \
               -e '/^Possible candidates/b ignore' \
               -e '/^def testmanager::webui::wuicontentbase::__init__/b ignore' \
               -e 'b nextwarning' \
               -e ':end' \
               -e 'p' \
               --output $(VBOX_CORE_DOXYFILE_OUTPUT)/errors2 \
               $(VBOX_CORE_DOXYFILE_OUTPUT)/errors
	$(CAT) $(VBOX_CORE_DOXYFILE_OUTPUT)/errors2
	$(SED) -e "/[^ ]/q 1" $(VBOX_CORE_DOXYFILE_OUTPUT)/errors2
	$(APPEND) $@

docs.Core docs.core: $(VBOX_CORE_DOXYFILE_OUTPUT)/docs.Core

#
# This is a bit odd, but we attach the optional scm check run onto the 'docs' pass
# so the build box output is less confusing on failure.
#
ifeq ($(KBUILD_HOST),$(KBUILD_TARGET))
 ifdef VBOX_WITH_SCM_CHECK_RUN
  docs: scm.check.run
 endif
 .PHONY: scm.check.run
 scm.check.run: $(VBOX_PATH_TOOLS)/scm$(HOSTSUFF_EXE)
	$(REDIRECT) -E VBOX_LOG_FLAGS="disabled" -E VBOX_LOG_DEST="nofile" -- \
		$(VBOX_PATH_TOOLS)/scm$(HOSTSUFF_EXE) -qvv --check-run $(PATH_ROOT)
endif


#
# Combined package build (windows only).
#
# The combined package is created by the x86 environment, so we do the amd64
# packaging in the build phase since it's just a few very slow jobs.  We hold
# back the x86 build until the amd64 packaging starts, to try encourage
# parallel execution.
#
# Note! VBOX_WITH_ADDITIONS_FROM_BUILD_SERVER=1 is required because the additions
#       packing must be done in amd64 mode as it picks files from the x86 build.
#

VBOX_COMBINED_PACKAGE_DEFS := \
	VBOX_WITH_COMBINED_PACKAGE=1 \
	VBOX_WITH_ALL_DOXYGEN_TARGETS= \
	VBOX_WITH_ADDITIONS_FROM_BUILD_SERVER=1

combined-package-fetch:
	+ $(KMK) -C tools $(VBOX_COMBINED_PACKAGE_DEFS) KBUILD_TARGET_ARCH=amd64 BUILD_TARGET_ARCH=amd64
	+ $(KMK) -C tools $(VBOX_COMBINED_PACKAGE_DEFS) KBUILD_TARGET_ARCH=x86   BUILD_TARGET_ARCH=x86

combined-package-build-amd64:
	+ $(KMK) docs all $(VBOX_COMBINED_PACKAGE_DEFS) KBUILD_TARGET_ARCH=amd64 BUILD_TARGET_ARCH=amd64

combined-package-build-amd64-packing: combined-package-build-amd64
	+ $(KMK) packing  $(VBOX_COMBINED_PACKAGE_DEFS) KBUILD_TARGET_ARCH=amd64 BUILD_TARGET_ARCH=amd64

combined-package-build-x86: combined-package-build-amd64
	+ $(KMK) docs all $(VBOX_COMBINED_PACKAGE_DEFS) KBUILD_TARGET_ARCH=x86 BUILD_TARGET_ARCH=x86

combined-package-build: combined-package-build-amd64-packing combined-package-build-x86

combined-package-packing:
	+ $(KMK) packing   $(VBOX_COMBINED_PACKAGE_DEFS) KBUILD_TARGET_ARCH=x86   BUILD_TARGET_ARCH=x86



#
# Common rsync bits.
#

##
# The basic rsync invocation for syncing the tree into a VM; the source and
# target specs are missing.
#
# @param    1   os name.
# @param    2   arch or *.
#
VBOX_RSYNC_IN_FN = rsync -a -v --delete --delete-excluded --prune-empty-dirs \
	--exclude=*.pyc \
	--exclude=.svn/ \
	--exclude=doc/Devices/ \
	--exclude=doc/tg/ \
	--exclude=doc/vp/ \
	--exclude=tinderclient.log \
	--exclude=tools/FetchDir/ \
	--exclude=webtools/ \
	--exclude=out/ \
	$(foreach os,$(filter-out $(1), darwin freebsd linux solaris os2 win), \
		--exclude=tools/$(os).x86/ \
		--exclude=tools/$(os).amd64/ )

#
# VM IP addresses.
#
VBOX_BLD_VM_LNX_IP               := 192.168.27.2
VBOX_BLD_VM_OS2_IP               := 192.168.27.3
VBOX_BLD_VM_SOLARIS_IP           := 192.168.27.4
VBOX_BLD_VM_DARWIN_X86_IP        := 192.168.27.5
VBOX_BLD_VM_DARWIN_AMD64_IP      := 192.168.27.15
VBOX_BLD_VM_DARWIN_109_AMD64_IP  := 192.168.27.18
VBOX_BLD_VM_WIN_X86_IP           := 192.168.27.6
VBOX_BLD_VM_WIN_AMD64_IP         := 192.168.27.16
VBOX_BLD_VM_FBSD_X86_IP          := 192.168.27.7
VBOX_BLD_VM_FBSD_AMD64_IP        := 192.168.27.17

VBOX_WITH_OS2_ADD_BUILD=1

#
# For profiling the VM building steps.
#
if 0
 VBOX_BLD_VM_MSG_BEGIN = $(call MSG_L1,Building $1.)
 VBOX_BLD_VM_MSG_END__ =
else
 VBOX_BLD_VM_MSG_BEGIN = @echo "$(date ) - Start building $1."
 VBOX_BLD_VM_MSG_END__ = @echo "$(date ) - Done building $1."
endif

#
# For killing old build jobs in the OS/2 VM before rsyncing.
#
VBOX_BLD_VM_OS2_KKILL_STUFF = $(REDIRECT_EXT) --stdin-pipe -- rsh -l vbox $(VBOX_BLD_VM_OS2_IP) "kkill -All -Tree kmk.exe gcc.exe & sleep.exe 1 & kkill -All gcc.exe emxomfld.exe as.exe kmk.exe "


#
# Build the additions, all of them.
#
# This is currently tailored (hardcoded) for the additions
# build box. Can make it pretty and configurable later.
#
# The fetching must be done in serial fashion, while the building
# should be more flexible wrt to -jN.
#
additions-fetch:
	+ $(KMK) -C tools fetch VBOX_ONLY_ADDITIONS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=darwin  BUILD_TARGET_ARCH=amd64 BUILD_TARGET=darwin   VBOX_ONLY_ADDITIONS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=darwin  BUILD_TARGET_ARCH=x86   BUILD_TARGET=darwin   VBOX_ONLY_ADDITIONS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=linux   BUILD_TARGET_ARCH=amd64 BUILD_TARGET=linux    VBOX_ONLY_ADDITIONS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=linux   BUILD_TARGET_ARCH=x86   BUILD_TARGET=linux    VBOX_ONLY_ADDITIONS=1
ifdef VBOX_WITH_OS2_ADD_BUILD
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=os2     BUILD_TARGET_ARCH=x86   BUILD_TARGET=os2	     VBOX_ONLY_ADDITIONS=1
endif
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=solaris BUILD_TARGET_ARCH=amd64 BUILD_TARGET=solaris  VBOX_ONLY_ADDITIONS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=solaris BUILD_TARGET_ARCH=x86   BUILD_TARGET=solaris  VBOX_ONLY_ADDITIONS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=win     BUILD_TARGET_ARCH=amd64 BUILD_TARGET=win	     VBOX_ONLY_ADDITIONS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=win     BUILD_TARGET_ARCH=x86   BUILD_TARGET=win	     VBOX_ONLY_ADDITIONS=1


## @todo Currently combined solaris additions building assumes that amd64 is
# built first. The windows amd64 additions need some x86 files, so don't change
# the order of the windows builds. TODO: Split building and packing for these two VMs.
additions-build: \
	additions-build-rsync-into-vms \
	additions-build-win.x86 \
	additions-build-win.amd64 \
	additions-build-solaris.amd64 \
	additions-build-solaris.x86 \
	additions-build-os2.x86 \
	additions-build-linux \
	additions-build-darwin.x86 \
	additions-build-darwin.amd64

additions-build-rsync-into-vms: \
		additions-build-solaris.rsync-into-vm \
		additions-build-os2.rsync-into-vm \
		additions-build-darwin.x86.rsync-into-vm \
		additions-build-darwin.amd64.rsync-into-vm \
		additions-build-linux.rsync-into-vm
	$(call MSG_L1,Rsynced the sources + tools into the VMs.)
.NOTPARALLEL: additions-build-rsync-into-vms
.PHONY:       additions-build-rsync-into-vms


VBOX_ADDITIONS_BUILD.amd64 = VBOX_ONLY_ADDITIONS=1 VBOX_WITHOUT_ADDITIONS_ISO=1 \
	KBUILD_TYPE=$(KBUILD_TYPE) BUILD_TYPE=$(KBUILD_TYPE) \
	KBUILD_TARGET_ARCH=amd64 BUILD_TARGET_ARCH=amd64 \
	VBOX_SVN_REV=$(VBOX_SVN_REV)

VBOX_ADDITIONS_BUILD.x86 = VBOX_ONLY_ADDITIONS=1 VBOX_WITHOUT_ADDITIONS_ISO=1 \
	KBUILD_TYPE=$(KBUILD_TYPE) BUILD_TYPE=$(KBUILD_TYPE) \
	KBUILD_TARGET_ARCH=x86 BUILD_TARGET_ARCH=x86 \
	VBOX_SVN_REV=$(VBOX_SVN_REV)

# Automatically determine the additions build subdir name. Used for figuring
# out directory names inside the additions building VMs.
VBOX_ADDITIONS_BUILD_SUBDIRNAME := $(lastword $(subst /, ,$(PATH_ROOT)))

# When building in parallel on a Windows host, make sure we finish the host
# bit before kicking off any UNIX guest or we'll run into file sharing issues.
ifeq ($(KBUILD_TARGET),win)
VBOX_ADDITIONS_BUILD_WIN_HOST_FIRST = #additions-build-win.x86 additions-build-win.amd64
else
VBOX_ADDITIONS_BUILD_WIN_HOST_FIRST =
endif

# ASSUMES the 32-bit edition has been built already. Also for serializing VM access.
ifeq ($(KBUILD_TARGET),win)
additions-build-win.amd64-just-build:
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.amd64) all $(VBOX_ADD_HOST_BUILD_TWEAK)
additions-build-win.amd64: additions-build-win.x86 additions-build-win.amd64-just-build
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.amd64) packing
else
additions-build-win.amd64: additions-build-win.x86
	$(call VBOX_BLD_VM_MSG_BEGIN,Windows/amd64 additions build+pack)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_WIN_AMD64_IP) ' cd e:/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh kmk $(VBOX_ADDITIONS_BUILD.amd64) all packing '
	$(call VBOX_BLD_VM_MSG_END__,Windows/amd64 additions build+pack)
endif

ifeq ($(KBUILD_TARGET),win)
additions-build-win.x86:
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) all $(VBOX_ADD_HOST_BUILD_TWEAK)
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) packing
else
additions-build-win.x86:
	$(call VBOX_BLD_VM_MSG_BEGIN,Windows/x86 additions build.pack)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_WIN_X86_IP) ' cd e:/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh kmk $(VBOX_ADDITIONS_BUILD.x86) all packing '
	$(call VBOX_BLD_VM_MSG_END__,Windows/x86 additions build+pack)
endif

# ASSUMES the 64-bit edition are built first. This also serializes VM access.
ifeq ($(KBUILD_TARGET),solaris)
additions-build-solaris.amd64:
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.amd64) all $(VBOX_ADD_HOST_BUILD_TWEAK)
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.amd64) packing

additions-build-solaris.x86: additions-build-solaris.amd64
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) VBOX_WITH_COMBINED_SOLARIS_GUEST_PACKAGE=1 all $(VBOX_ADD_HOST_BUILD_TWEAK)
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) VBOX_WITH_COMBINED_SOLARIS_GUEST_PACKAGE=1 packing

additions-build-solaris.rsync-into-vm:
else
additions-build-solaris.rsync-into-vm:
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,solaris,*) \
		'--exclude=src/VBox/Additions/WINNT/**' \
		'--exclude=src/VBox/Frontends/**' \
		'--exclude=src/VBox/VMM/**' \
		. $(VBOX_BLD_VM_SOLARIS_IP):/mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)

additions-build-solaris.build-it: additions-build-solaris.rsync-into-vm
	$(call VBOX_BLD_VM_MSG_BEGIN,Solaris/amd64 additions build+pack)
	$(TIME) -- ssh -v vbox@$(VBOX_BLD_VM_SOLARIS_IP) ' cd /mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.amd64) all packing '
	$(call VBOX_BLD_VM_MSG_END__,Solaris/amd64 additions build+pack)
	$(call VBOX_BLD_VM_MSG_BEGIN,Solaris/x86 additions build+pack)
	$(TIME) -- ssh -v vbox@$(VBOX_BLD_VM_SOLARIS_IP) ' cd /mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.x86) all packing VBOX_WITH_COMBINED_SOLARIS_GUEST_PACKAGE=1 '
	$(call VBOX_BLD_VM_MSG_END__,Solaris/x86 additions build+pack)

additions-build-solaris.rsync-out-of-vm: additions-build-solaris.build-it
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_SOLARIS_IP):/mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)/out/solaris.x86 out/
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_SOLARIS_IP):/mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)/out/solaris.amd64 out/

.NOTPARALLEL: additions-build-solaris.rsync-into-vm
.PHONY:       additions-build-solaris.rsync-into-vm additions-build-solaris.rsync-out-of-vm additions-build-solaris.build-it

additions-build-solaris.amd64: additions-build-solaris.rsync-out-of-vm
additions-build-solaris.x86:   additions-build-solaris.rsync-out-of-vm
endif

ifdef VBOX_WITH_OS2_ADD_BUILD
 ifeq ($(KBUILD_TARGET),os2)
additions-build-os2.x86:
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) all $(VBOX_ADD_HOST_BUILD_TWEAK)
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) packing

additions-build-os2.rsync-into-vm:
 else
additions-build-os2.rsync-into-vm:
	-$(VBOX_BLD_VM_OS2_KKILL_STUFF)
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,os2,*) \
		'--exclude=src/VBox/Additions/x11/**' \
		'--exclude=src/VBox/Additions/WINNT/**' \
		'--exclude=src/VBox/Frontends/**' \
		'--exclude=src/VBox/VMM/**' \
		. rsync://vbox@$(VBOX_BLD_VM_OS2_IP)/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)

additions-build-os2.build-it: #additions-build-os2.rsync-into-vm
	$(call VBOX_BLD_VM_MSG_BEGIN,OS/2 additions build+pack)
	$(TIME) -- $(REDIRECT_EXT) --stdin-pipe -- rsh -l vbox $(VBOX_BLD_VM_OS2_IP) "cd e:\\tinderbox\\$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && e: && kbuild\\bin\\os2.x86\\kmk_ash tools\\env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.x86) all packing"
	$(call VBOX_BLD_VM_MSG_END__,OS/2 additions build+pack)

additions-build-os2.rsync-out-of-vm: additions-build-os2.build-it
	-$(VBOX_BLD_VM_OS2_KKILL_STUFF)
	$(TIME) -- rsync -v -a --delete rsync://vbox@$(VBOX_BLD_VM_OS2_IP)/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)/out/os2.x86 ./out

.NOTPARALLEL: additions-build-os2.rsync-into-vm
.PHONY:       additions-build-os2.rsync-into-vm additions-build-os2.rsync-out-of-vm additions-build-os2.build-it

additions-build-os2.x86: additions-build-os2.rsync-out-of-vm
 endif
#
else
additions-build-os2.x86:
# Dummy
endif

# Linux
ifeq ($(KBUILD_TARGET),linux)
additions-build-linux.amd64:
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.amd64) all $(VBOX_ADD_HOST_BUILD_TWEAK)
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.amd64) packing VBOX_WITHOUT_LINUX_GUEST_PACKAGE=1

additions-build-linux.x86:
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) all $(VBOX_ADD_HOST_BUILD_TWEAK)
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) packing VBOX_WITHOUT_LINUX_GUEST_PACKAGE=1

additions-build-linux: additions-build-linux.x86 additions-build-linux.amd64
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) all $(VBOX_ADD_HOST_BUILD_TWEAK)
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) packing VBOX_WITH_COMBINED_LINUX_GUEST_PACKAGE=1
else
additions-build-linux.rsync-into-vm:
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,linux,*) \
		'--exclude=src/VBox/Additions/WINNT/**' \
		'--exclude=src/VBox/Frontends/**' \
		'--exclude=src/VBox/VMM/**' \
		. $(VBOX_BLD_VM_LNX_IP):/mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)

additions-build-linux.build-it: additions-build-linux.rsync-into-vm
 ifdef VBOX_WITH_LIGHTDM_GREETER_PACKING
	$(call VBOX_BLD_VM_MSG_BEGIN,Linux/amd64 additions/greeter)
	$(TIME) -- ssh -v vbox@$(VBOX_BLD_VM_LNX_IP)         'dchroot -c ubuntu-11.10-amd64 "cd /mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.amd64) PATH_OUT=/mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)/out/linux.amd64/$(KBUILD_TYPE)/greeter VBOX_WITH_LIGHTDM_GREETER=1 vbox-greeter " '
	$(call VBOX_BLD_VM_MSG_END__,Linux/amd64 additions/greeter)
 endif
	$(call VBOX_BLD_VM_MSG_BEGIN,Linux/amd64 additions build+pack)
	$(TIME) -- ssh -v vbox@$(VBOX_BLD_VM_LNX_IP)         'dchroot -c debian-4.0-amd64   "cd /mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.amd64) all packing VBOX_WITHOUT_LINUX_GUEST_PACKAGE=1 VBOX_WITH_LIGHTDM_GREETER_PACKING=$(VBOX_WITH_LIGHTDM_GREETER_PACKING) " '
	$(call VBOX_BLD_VM_MSG_END__,Linux/amd64 additions build+pack)
 ifdef VBOX_WITH_LIGHTDM_GREETER_PACKING
	$(call VBOX_BLD_VM_MSG_BEGIN,Linux/x86 additions/greeter)
	$(TIME) -- ssh -v vbox@$(VBOX_BLD_VM_LNX_IP) 'linux32 dchroot -c ubuntu-11.10-i386  "cd /mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && BUILD_PLATFORM_ARCH=x86 tools/env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.x86) PATH_OUT=/mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)/out/linux.x86/$(KBUILD_TYPE)/greeter VBOX_WITH_LIGHTDM_GREETER=1 vbox-greeter " '
	$(call VBOX_BLD_VM_MSG_END__,Linux/x86 additions/greeter)
 endif
	$(call VBOX_BLD_VM_MSG_BEGIN,Linux/x86 additions build+pack)
	$(TIME) -- ssh -v vbox@$(VBOX_BLD_VM_LNX_IP) 'linux32 dchroot -c rhel3-i386         "cd /mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.x86) all packing VBOX_WITHOUT_LINUX_GUEST_PACKAGE=1 VBOX_WITH_LIGHTDM_GREETER_PACKING=$(VBOX_WITH_LIGHTDM_GREETER_PACKING) " '
	$(call VBOX_BLD_VM_MSG_END__,Linux/x86 additions build+pack)
	$(call VBOX_BLD_VM_MSG_BEGIN,Linux/x86 additions combine)
	$(TIME) -- ssh -v vbox@$(VBOX_BLD_VM_LNX_IP) 'linux32 dchroot -c rhel3-i386         "cd /mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.x86) all packing VBOX_WITH_COMBINED_LINUX_GUEST_PACKAGE=1 " '
	$(call VBOX_BLD_VM_MSG_END__,Linux/x86 additions combine)

additions-build-linux.rsync-out-of-vm: additions-build-linux.build-it
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_LNX_IP):/mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)/out/linux.x86 out/
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_LNX_IP):/mnt/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)/out/linux.amd64 out/

.NOTPARALLEL: additions-build-linux.rsync-into-vm
.PHONY:       additions-build-linux.rsync-into-vm additions-build-linux.rsync-out-of-vm additions-build-linux.build-it

additions-build-linux: additions-build-linux.rsync-out-of-vm
endif

# Darwin
ifeq ($(KBUILD_TARGET),darwin)
additions-build-darwin.amd64:
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.amd64) all $(VBOX_ADD_HOST_BUILD_TWEAK)
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.amd64) packing

additions-build-darwin.x86:
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) all $(VBOX_ADD_HOST_BUILD_TWEAK)
	+ $(TIME) -- $(KMK) $(VBOX_ADDITIONS_BUILD.x86) packing

additions-build-darwin:   additions-build-darwin.amd64 additions-build-darwin.x86
.PHONY:       additions-build-darwin.amd64 additions-build-darwin.x86
else
additions-build-darwin.amd64.rsync-into-vm:
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,darwin,*) \
		'--exclude=src/libs/xpcom18a4/**' \
		'--exclude=src/libs/curl*/**' \
		'--exclude=src/libs/libxml*/**' \
		'--exclude=src/libs/libvpx*/**' \
		'--exclude=src/libs/libopus*/**' \
		'--exclude=src/VBox/Additions/WINNT/**' \
		'--exclude=src/VBox/Additions/x11/**' \
		'--exclude=src/VBox/Artwork/x11/**' \
		'--exclude=src/VBox/Devices/**' \
		'--exclude=src/VBox/Disassembler/**' \
		'--exclude=src/VBox/ExtPacks/**' \
		'--exclude=src/VBox/Frontends/**' \
		'--exclude=src/VBox/HostDriver/**' \
		'--exclude=src/VBox/HostService/**' \
		'--exclude=src/VBox/ImageMounter/**' \
		'--exclude=src/VBox/Installer/**' \
		'--exclude=src/VBox/Main/**' \
		'--exclude=src/VBox/NetworkService/**' \
		'--exclude=src/VBox/RDP/**' \
		'--exclude=src/VBox/Storage/**' \
		'--exclude=src/VBox/ValidationKit/**' \
		'--exclude=src/VBox/VMM/**' \
		'--exclude=src/apps/**' \
		'--exclude=src/recompiler/**' \
		. $(VBOX_BLD_VM_DARWIN_109_AMD64_IP):/Users/vbox/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)

additions-build-darwin.x86.rsync-into-vm:
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,darwin,*) \
		'--exclude=src/libs/xpcom18a4/**' \
		'--exclude=src/libs/curl*/**' \
		'--exclude=src/libs/libxml*/**' \
		'--exclude=src/libs/libvpx*/**' \
		'--exclude=src/libs/libopus*/**' \
		'--exclude=src/VBox/Additions/WINNT/**' \
		'--exclude=src/VBox/Additions/x11/**' \
		'--exclude=src/VBox/Artwork/x11/**' \
		'--exclude=src/VBox/Devices/**' \
		'--exclude=src/VBox/Disassembler/**' \
		'--exclude=src/VBox/ExtPacks/**' \
		'--exclude=src/VBox/Frontends/**' \
		'--exclude=src/VBox/HostDriver/**' \
		'--exclude=src/VBox/HostService/**' \
		'--exclude=src/VBox/ImageMounter/**' \
		'--exclude=src/VBox/Installer/**' \
		'--exclude=src/VBox/Main/**' \
		'--exclude=src/VBox/NetworkService/**' \
		'--exclude=src/VBox/RDP/**' \
		'--exclude=src/VBox/Storage/**' \
		'--exclude=src/VBox/ValidationKit/**' \
		'--exclude=src/VBox/VMM/**' \
		'--exclude=src/apps/**' \
		'--exclude=src/recompiler/**' \
		. $(VBOX_BLD_VM_DARWIN_X86_IP):/Users/vbox/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)

additions-build-darwin.amd64.build-it: additions-build-darwin.amd64.rsync-into-vm
	$(call VBOX_BLD_VM_MSG_BEGIN,Darwin/amd64 Additions)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_DARWIN_109_AMD64_IP) 'cd /Users/vbox/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.amd64) all packing'
	$(call VBOX_BLD_VM_MSG_END__,Darwin/amd64 Additions)

additions-build-darwin.x86.build-it: additions-build-darwin.x86.rsync-into-vm
	$(call VBOX_BLD_VM_MSG_BEGIN,Darwin/x86 Additions)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_DARWIN_X86_IP) 'cd /Users/vbox/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_ADDITIONS_BUILD.x86) all packing'
	$(call VBOX_BLD_VM_MSG_END__,Darwin/x86 Additions)

additions-build-darwin.amd64.rsync-out-of-vm: additions-build-darwin.amd64.build-it
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_DARWIN_109_AMD64_IP):/Users/vbox/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)/out/darwin.amd64 out/

additions-build-darwin.x86.rsync-out-of-vm: additions-build-darwin.x86.build-it
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_DARWIN_X86_IP):/Users/vbox/tinderbox/$(VBOX_ADDITIONS_BUILD_SUBDIRNAME)/out/darwin.x86 out/

additions-build-darwin.amd64: additions-build-darwin.amd64.rsync-out-of-vm
additions-build-darwin.x86: additions-build-darwin.x86.rsync-out-of-vm
additions-build-darwin: additions-build-darwin.x86.rsync-out-of-vm  additions-build-darwin.amd64.rsync-out-of-vm

.PHONY: additions-build-darwin.amd64.rsync-into-vm additions-build-darwin.amd64.rsync-out-of-vm additions-build-darwin.amd64.build-it \
	additions-build-darwin.x86.rsync-into-vm additions-build-darwin.x86.rsync-out-of-vm additions-build-darwin.x86.build-it
endif


additions-packing:
	+ $(KMK) VBOX_ONLY_ADDITIONS=1 \
		VBOX_WITH_ADDITIONS_ISO.darwin.amd64=1 \
		VBOX_WITH_ADDITIONS_ISO.darwin.x86=1 \
		VBOX_WITH_ADDITIONS_ISO.freebsd.amd64= \
		VBOX_WITH_ADDITIONS_ISO.freebsd.x86= \
		VBOX_WITH_ADDITIONS_ISO.linux.amd64= \
		VBOX_WITH_ADDITIONS_ISO.linux.x86=1 \
		VBOX_WITH_COMBINED_LINUX_GUEST_PACKAGE=1 \
		VBOX_WITH_ADDITIONS_ISO.os2.x86=1 \
		VBOX_WITH_ADDITIONS_ISO.solaris.amd64=1 \
		VBOX_WITH_ADDITIONS_ISO.solaris.x86=1 \
		VBOX_WITH_COMBINED_SOLARIS_GUEST_PACKAGE=1 \
		VBOX_WITH_ADDITIONS_ISO.win.amd64=1 \
		VBOX_WITH_ADDITIONS_ISO.win.x86=1 \
		-C src/VBox/Additions \
		$(VBOX_PATH_ADDITIONS)/VBoxGuestAdditions.zip

.PHONY: \
	additions-build-win.x86 \
	additions-build-win.amd64 \
	additions-build-solaris.amd64 \
	additions-build-solaris.x86 \
	additions-build-os2.x86 \
	additions-build-linux \
	additions-build-linux.amd64 \
	additions-build-linux.x86 \
	additions-build-linux.x86.combined \
	additions-build-darwin \
	additions-build-darwin.x86 \
	additions-build-darwin.amd64 \
	additions-packing


#
# Build the extension packs, all of them.
#
# This is tailored (hardcoded) for the extension pack build box.
#
# The fetching must be done in serial fashion, while the building should be
# more flexible wrt to -jN.
#
extpacks-fetch:
	+ $(KMK) -C tools fetch VBOX_ONLY_EXTPACKS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=darwin  BUILD_TARGET_ARCH=amd64 BUILD_TARGET=darwin   VBOX_ONLY_EXTPACKS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=darwin  BUILD_TARGET_ARCH=x86   BUILD_TARGET=darwin   VBOX_ONLY_EXTPACKS=1
#	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=freebsd BUILD_TARGET_ARCH=amd64 BUILD_TARGET=freebsd  VBOX_ONLY_EXTPACKS=1
#	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=freebsd BUILD_TARGET_ARCH=x86   BUILD_TARGET=freebsd  VBOX_ONLY_EXTPACKS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=linux   BUILD_TARGET_ARCH=amd64 BUILD_TARGET=linux    VBOX_ONLY_EXTPACKS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=linux   BUILD_TARGET_ARCH=x86   BUILD_TARGET=linux    VBOX_ONLY_EXTPACKS=1
#	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=os2     BUILD_TARGET_ARCH=x86   BUILD_TARGET=os2      VBOX_ONLY_EXTPACKS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=solaris BUILD_TARGET_ARCH=amd64 BUILD_TARGET=solaris  VBOX_ONLY_EXTPACKS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=win     BUILD_TARGET_ARCH=amd64 BUILD_TARGET=win	     VBOX_ONLY_EXTPACKS=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=win     BUILD_TARGET_ARCH=x86   BUILD_TARGET=win	     VBOX_ONLY_EXTPACKS=1


extpacks-build: \
	extpacks-build-win.amd64 \
	extpacks-build-win.x86 \
	extpacks-build-solaris.amd64 \
	extpacks-build-os2.x86 \
	extpacks-build-linux \
	extpacks-build-darwin.amd64 \
	extpacks-build-freebsd.amd64 \
	extpacks-build-freebsd.x86

VBOX_EXTPACKS_BUILD.amd64 = VBOX_ONLY_EXTPACKS=1 \
	KBUILD_TYPE=$(KBUILD_TYPE) BUILD_TYPE=$(KBUILD_TYPE) \
	KBUILD_TARGET_ARCH=amd64 BUILD_TARGET_ARCH=amd64 \
	VBOX_SVN_REV=$(VBOX_SVN_REV)

VBOX_EXTPACKS_BUILD.x86 = VBOX_ONLY_EXTPACKS=1 \
	KBUILD_TYPE=$(KBUILD_TYPE) BUILD_TYPE=$(KBUILD_TYPE) \
	KBUILD_TARGET_ARCH=x86 BUILD_TARGET_ARCH=x86 \
	VBOX_SVN_REV=$(VBOX_SVN_REV)

# Automatically determine the extpack build subdir name. Used for figuring out
# directory names inside the extension pack building VMs.
VBOX_EXTPACKS_BUILD_SUBDIRNAME := $(lastword $(subst /, ,$(PATH_ROOT)))

# When building in parallel on a Windows host, make sure we finish the host
# bit before kicking off any UNIX guest or we'll run into file sharing issues.
ifeq ($(KBUILD_TARGET),win)
VBOX_EXTPACKS_BUILD_WIN_HOST_FIRST = extpacks-build-win.x86 extpacks-build-win.amd64
else
VBOX_EXTPACKS_BUILD_WIN_HOST_FIRST =
endif

extpacks-build-win.amd64:
ifeq ($(KBUILD_TARGET),win)
	+ $(TIME) -- $(KMK) $(VBOX_EXTPACKS_BUILD.amd64) all $(VBOX_EXTPACKS_HOST_BUILD_TWEAK)
else
	$(call VBOX_BLD_VM_MSG_BEGIN,Windows/amd64 extension packs)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_WIN_AMD64_IP) 'cd e:/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME) && tools/env.sh kmk $(VBOX_EXTPACKS_BUILD.amd64) all '
	$(call VBOX_BLD_VM_MSG_END__,Windows/amd64 extension packs)
endif

extpacks-build-win.x86:
ifeq ($(KBUILD_TARGET),win)
	+ $(TIME) -- $(KMK) $(VBOX_EXTPACKS_BUILD.x86) all $(VBOX_EXTPACKS_HOST_BUILD_TWEAK)
else
	$(call VBOX_BLD_VM_MSG_BEGIN,Windows/x86 extension packs)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_WIN_X86_IP) 'cd e:/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME) && tools/env.sh kmk $(VBOX_EXTPACKS_BUILD.x86) all '
	$(call VBOX_BLD_VM_MSG_END__,Windows/x86 extension packs)
endif

ifeq ($(KBUILD_TARGET),solaris)
extpacks-build-solaris.amd64:
	+ $(TIME) -- $(KMK) $(VBOX_EXTPACKS_BUILD.amd64) all $(VBOX_EXTPACKS_HOST_BUILD_TWEAK)

else
# Serialize 32-bit and 64-bit ASSUMING the same VM builds both.
extpacks-build-solaris.rsync-into-vm: $(VBOX_EXTPACKS_BUILD_WIN_HOST_FIRST)
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,solaris,*) . $(VBOX_BLD_VM_SOLARIS_IP):/mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME)

extpacks-build-solaris.build-it: extpacks-build-solaris.rsync-into-vm
	$(call VBOX_BLD_VM_MSG_BEGIN,Solaris/amd64 extension packs)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_SOLARIS_IP)  'cd /mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_EXTPACKS_BUILD.amd64) all '
	$(call VBOX_BLD_VM_MSG_END__,Solaris/amd64 extension packs)

extpacks-build-solaris.rsync-out-of-vm: extpacks-build-solaris.build-it
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_SOLARIS_IP):/mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME)/out/solaris.amd64 out/

#.NOTPARALLEL: extpacks-build-solaris.rsync-into-vm
.PHONY:       extpacks-build-solaris.rsync-out-of-vm extpacks-build-solaris.rsync-into-vm extpacks-build-solaris.build-it

extpacks-build-solaris.amd64: extpacks-build-solaris.rsync-out-of-vm
endif

extpacks-build-os2.x86:
#ifeq ($(KBUILD_TARGET),os2)
#	+ $(TIME) -- $(KMK) $(VBOX_EXTPACKS_BUILD.x86) all $(VBOX_EXTPACKS_HOST_BUILD_TWEAK)
#else
#	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_OS2_IP) ' cd /mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_EXTPACKS_BUILD.x86) '
#endif

ifeq ($(KBUILD_TARGET),linux)
extpacks-build-linux.amd64:   $(VBOX_EXTPACKS_BUILD_WIN_HOST_FIRST)
	+ $(TIME) -- $(KMK) $(VBOX_EXTPACKS_BUILD.amd64) all $(VBOX_EXTPACKS_HOST_BUILD_TWEAK)

extpacks-build-linux.x86:   $(VBOX_EXTPACKS_BUILD_WIN_HOST_FIRST)
	+ $(TIME) -- $(KMK) $(VBOX_EXTPACKS_BUILD.x86) all $(VBOX_EXTPACKS_HOST_BUILD_TWEAK)

extpacks-build-linux: extpacks-build-linux.x86 extpacks-build-linux.amd64
else
# Serialize 32-bit and 64-bit ASSUMING the same VM builds both.
extpacks-build-linux.rsync-into-vm: $(VBOX_EXTPACKS_BUILD_WIN_HOST_FIRST)
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,linux,*) . $(VBOX_BLD_VM_LNX_IP):/mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME)

extpacks-build-linux.build-it: extpacks-build-linux.rsync-into-vm
	$(call VBOX_BLD_VM_MSG_BEGIN,Linux/amd64 extension packs)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_LNX_IP)         'dchroot -c debian-4.0-amd64 "cd /mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_EXTPACKS_BUILD.amd64) all " '
	$(call VBOX_BLD_VM_MSG_END__,Linux/amd64 extension packs)
	$(call VBOX_BLD_VM_MSG_BEGIN,Linux/x86 extension packs)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_LNX_IP) 'linux32 dchroot -c debian-4.0-i386  "cd /mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_EXTPACKS_BUILD.x86)   all " '
	$(call VBOX_BLD_VM_MSG_END__,Linux/x86 extension packs)

extpacks-build-linux.rsync-out-of-vm: extpacks-build-linux.build-it
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_LNX_IP):/mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME)/out/linux.x86 out/
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_LNX_IP):/mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME)/out/linux.amd64 out/

#.NOTPARALLEL: extpacks-build-linux.rsync-into-vm
.PHONY:       extpacks-build-linux.rsync-out-of-vm extpacks-build-linux.rsync-into-vm extpacks-build-linux.build-it

extpacks-build-linux: extpacks-build-linux.rsync-out-of-vm
endif

extpacks-build-freebsd.amd64: $(VBOX_EXTPACKS_BUILD_WIN_HOST_FIRST)
#ifeq ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),freebsd.amd64)
#	+ $(TIME) -- $(KMK) $(VBOX_EXTPACKS_BUILD.amd64) all $(VBOX_EXTPACKS_HOST_BUILD_TWEAK)
#else
#	$(call VBOX_BLD_VM_MSG_BEGIN,FreeBSD/amd64 extension packs)
#	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_FBSD_AMD64_IP) 'cd /mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_EXTPACKS_BUILD.amd64) all '
#	$(call VBOX_BLD_VM_MSG_END__,FreeBSD/amd64 extension packs)
#endif

extpacks-build-freebsd.x86: $(VBOX_EXTPACKS_BUILD_WIN_HOST_FIRST)
#ifeq ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),freebsd.x86)
#	+ $(TIME) -- $(KMK) $(VBOX_EXTPACKS_BUILD.x86) all $(VBOX_EXTPACKS_HOST_BUILD_TWEAK)
#else
#	$(call VBOX_BLD_VM_MSG_BEGIN,FreeBSD/x86 extension packs)
#	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_FBSD_X86_IP) 'cd /mnt/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_EXTPACKS_BUILD.x86) all '
#	$(call VBOX_BLD_VM_MSG_END__,FreeBSD/x86 extension packs)
#endif

extpacks-build-darwin.amd64: $(VBOX_EXTPACKS_BUILD_WIN_HOST_FIRST)
ifeq ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),darwin.amd64)
	+ $(TIME) -- $(KMK) $(VBOX_EXTPACKS_BUILD.amd64) all $(VBOX_EXTPACKS_HOST_BUILD_TWEAK)
else
	$(call VBOX_BLD_VM_MSG_BEGIN,Darwin/amd64 extension packs)
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,darwin,amd64) . $(VBOX_BLD_VM_DARWIN_109_AMD64_IP):/Users/vbox/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_DARWIN_109_AMD64_IP) 'PATH=$$PATH:/opt/local/bin; cd /Users/vbox/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME) && KBUILD_HOST_ARCH=amd64 tools/env.sh --no-wine kmk $(VBOX_EXTPACKS_BUILD.amd64) all '
	$(TIME) -- rsync -am -v --delete $(VBOX_BLD_VM_DARWIN_109_AMD64_IP):/Users/vbox/tinderbox/$(VBOX_EXTPACKS_BUILD_SUBDIRNAME)/out/darwin.amd64 out/
	$(call VBOX_BLD_VM_MSG_END__,Darwin/amd64 extension packs)
endif

extpacks-packing:
	+ $(KMK) VBOX_ONLY_EXTPACKS=1 \
		VBOX_WITH_EXTPACK_OS_ARCHS="darwin.amd64 linux.amd64 linux.x86 solaris.amd64 win.amd64 win.x86" \
		packing
# +++ freebsd.amd64 freebsd.x86 os2.x86 ^^^

.PHONY: \
	extpacks-build-win.x86 \
	extpacks-build-win.amd64 \
	extpacks-build-solaris.amd64 \
	extpacks-build-os2.x86 \
	extpacks-build-linux \
	extpacks-build-linux.amd64 \
	extpacks-build-linux.x86 \
	extpacks-build-freebsd.amd64 \
	extpacks-build-freebsd.x86 \
	extpacks-build-darwin.amd64 \
	extpacks-packing


#
# Build the test suite, all of it.
#
# This is currently tailored (hardcoded) for the additions build box just like
# the additions build above, which it in fact is a copy of.
#
validationkit-fetch:
	+ $(KMK) -C tools fetch VBOX_ONLY_VALIDATIONKIT=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=darwin  BUILD_TARGET_ARCH=amd64 BUILD_TARGET=darwin    VBOX_ONLY_VALIDATIONKIT=1 VBOX_DEF_MACOSX_VERSION_MIN=10.7
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=darwin  BUILD_TARGET_ARCH=x86   BUILD_TARGET=darwin    VBOX_ONLY_VALIDATIONKIT=1 ##@todo VBOX_DEF_MACOSX_VERSION_MIN=10.4
#	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=freebsd BUILD_TARGET_ARCH=amd64 BUILD_TARGET=freebsd   VBOX_ONLY_VALIDATIONKIT=1
#	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=freebsd BUILD_TARGET_ARCH=x86   BUILD_TARGET=freebsd   VBOX_ONLY_VALIDATIONKIT=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=linux   BUILD_TARGET_ARCH=amd64 BUILD_TARGET=linux     VBOX_ONLY_VALIDATIONKIT=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=linux   BUILD_TARGET_ARCH=x86   BUILD_TARGET=linux     VBOX_ONLY_VALIDATIONKIT=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=os2     BUILD_TARGET_ARCH=x86   BUILD_TARGET=os2       VBOX_ONLY_VALIDATIONKIT=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=solaris BUILD_TARGET_ARCH=amd64 BUILD_TARGET=solaris   VBOX_ONLY_VALIDATIONKIT=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=solaris BUILD_TARGET_ARCH=x86   BUILD_TARGET=solaris   VBOX_ONLY_VALIDATIONKIT=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=amd64 KBUILD_TARGET=win     BUILD_TARGET_ARCH=amd64 BUILD_TARGET=win       VBOX_ONLY_VALIDATIONKIT=1
	+ $(KMK) -C tools fetch KBUILD_TARGET_ARCH=x86   KBUILD_TARGET=win     BUILD_TARGET_ARCH=x86   BUILD_TARGET=win       VBOX_ONLY_VALIDATIONKIT=1


validationkit-build: \
	validationkit-build-rsync-into-vms \
	validationkit-build-solaris.amd64 \
	validationkit-build-solaris.x86 \
	validationkit-build-win.x86 \
	validationkit-build-win.amd64 \
	validationkit-build-os2.x86 \
	validationkit-build-linux \
	validationkit-build-freebsd.amd64 \
	validationkit-build-freebsd.x86 \
	validationkit-build-darwin.amd64 \
	validationkit-build-darwin.x86

validationkit-build-rsync-into-vms: \
		validationkit-build-solaris.rsync-into-vm \
		validationkit-build-os2.rsync-into-vm \
		validationkit-build-linux.rsync-into-vm
	$(call MSG_L1,Rsynced the sources + tools into the VMs.)
.NOTPARALLEL: validationkit-build-rsync-into-vms
.PHONY:       validationkit-build-rsync-into-vms


VBOX_VALIDATIONKIT_BUILD.amd64 = VBOX_ONLY_VALIDATIONKIT=1 \
	KBUILD_TYPE=$(KBUILD_TYPE) BUILD_TYPE=$(KBUILD_TYPE) \
	KBUILD_TARGET_ARCH=amd64 BUILD_TARGET_ARCH=amd64 \
	VBOX_SVN_REV=$(VBOX_SVN_REV)

VBOX_VALIDATIONKIT_BUILD.x86 = VBOX_ONLY_VALIDATIONKIT=1 \
	KBUILD_TYPE=$(KBUILD_TYPE) BUILD_TYPE=$(KBUILD_TYPE) \
	KBUILD_TARGET_ARCH=x86 BUILD_TARGET_ARCH=x86 \
	VBOX_SVN_REV=$(VBOX_SVN_REV)

# Automatically determine the Validation Kit build subdir name. Used for figuring
# out directory names inside the test suite building VMs.
VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME := $(lastword $(subst /, ,$(PATH_ROOT)))

# When building in parallel on a Windows host, make sure we finish the host
# bit before kicking off any UNIX guest or we'll run into file sharing issues.
ifeq ($(KBUILD_TARGET),win)
VBOX_VALIDATIONKIT_BUILD_WIN_HOST_FIRST = validationkit-build-win.x86 validationkit-build-win.amd64
else
VBOX_VALIDATIONKIT_BUILD_WIN_HOST_FIRST =
endif

validationkit-build-win.amd64:
ifeq ($(KBUILD_TARGET),win)
	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.amd64) all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)
else
	$(call VBOX_BLD_VM_MSG_BEGIN,Windows/amd64 Validation Kit)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_WIN_X86_IP) 'cd e:/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh kmk $(VBOX_VALIDATIONKIT_BUILD.amd64) all '
	$(call VBOX_BLD_VM_MSG_END__,Windows/amd64 Validation Kit)
endif

validationkit-build-win.x86:
ifeq ($(KBUILD_TARGET),win)
	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.x86) all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)
else
	$(call VBOX_BLD_VM_MSG_BEGIN,Windows/x86 Validation Kit)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_WIN_AMD64_IP) 'cd e:/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh kmk $(VBOX_VALIDATIONKIT_BUILD.x86) all '
	$(call VBOX_BLD_VM_MSG_END__,Windows/x86 Validation Kit)
endif

ifeq ($(KBUILD_TARGET),solaris)
validationkit-build-solaris.amd64:
	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.amd64) all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)

validationkit-build-solaris.x86:
	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.x86)   all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)

else
validationkit-build-solaris.rsync-into-vm: $(VBOX_VALIDATIONKIT_BUILD_WIN_HOST_FIRST)
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,solaris,*) \
		'--exclude=src/VBox/Additions/WINNT/**' \
		'--exclude=src/VBox/Frontends/**' \
		'--exclude=src/VBox/VMM/**' \
		. $(VBOX_BLD_VM_SOLARIS_IP):/mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)

validationkit-build-solaris.build-it: validationkit-build-solaris.rsync-into-vm
	$(call VBOX_BLD_VM_MSG_BEGIN,Solaris/amd64 Validation Kit)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_SOLARIS_IP) 'cd /mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.amd64) all '
	$(call VBOX_BLD_VM_MSG_END__,Solaris/amd64 Validation Kit)
	$(call VBOX_BLD_VM_MSG_BEGIN,Solaris/x86 Validation Kit)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_SOLARIS_IP) 'cd /mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.x86) all '
	$(call VBOX_BLD_VM_MSG_END__,Solaris/x86 Validation Kit)

validationkit-build-solaris.rsync-out-of-vm: validationkit-build-solaris.build-it
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_SOLARIS_IP):/mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)/out/solaris.x86   out/
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_SOLARIS_IP):/mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)/out/solaris.amd64 out/

.PHONY:       validationkit-build-solaris.rsync-out-of-vm validationkit-build-solaris.rsync-into-vm validationkit-build-solaris.build-it

validationkit-build-solaris.amd64: validationkit-build-solaris.rsync-out-of-vm
validationkit-build-solaris.x86:   validationkit-build-solaris.rsync-out-of-vm
endif

ifeq ($(KBUILD_TARGET),os2)
validationkit-build-os2.x86:
	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.x86) all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)
validationkit-build-os2.rsync-into-vm:
else # !OS/2
validationkit-build-os2.rsync-into-vm:
	-$(VBOX_BLD_VM_OS2_KKILL_STUFF)
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,os2,*) \
		'--exclude=src/VBox/Additions/x11/**' \
		'--exclude=src/VBox/Additions/WINNT/**' \
		'--exclude=src/VBox/Frontends/**' \
		'--exclude=src/VBox/VMM/**' \
		. rsync://vbox@$(VBOX_BLD_VM_OS2_IP)/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)

validationkit-build-os2.build-it: validationkit-build-os2.rsync-into-vm
	$(call VBOX_BLD_VM_MSG_BEGIN,OS/2 Validation Kit)
	$(TIME) -- $(REDIRECT_EXT) --stdin-pipe -- rsh -l vbox $(VBOX_BLD_VM_OS2_IP) "cd e:\\tinderbox\\$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && e: && kbuild\\bin\\os2.x86\\kmk_ash tools\\env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.x86) all"
	$(call VBOX_BLD_VM_MSG_END__,OS/2 Validation Kit)

validationkit-build-os2.rsync-out-of-vm: validationkit-build-os2.build-it
	-$(VBOX_BLD_VM_OS2_KKILL_STUFF)
	$(TIME) -- rsync -v -a --delete rsync://vbox@$(VBOX_BLD_VM_OS2_IP)/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)/out/os2.x86 ./out

.PHONY:       validationkit-build-os2.rsync-into-vm validationkit-build-os2.rsync-out-of-vm validationkit-build-os2.build-it

validationkit-build-os2.x86: validationkit-build-os2.rsync-out-of-vm
endif # !OS/2

ifeq ($(KBUILD_TARGET),linux)
validationkit-build-linux.amd64:
	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.amd64) all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)

validationkit-build-linux.x86:
	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.x86)   all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)

validationkit-build-linux: validationkit-build-linux.x86 validationkit-build-linux.amd64
else
validationkit-build-linux.rsync-into-vm: $(VBOX_VALIDATIONKIT_BUILD_WIN_HOST_FIRST)
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,linux,*) \
		'--exclude=src/VBox/Additions/WINNT/**' \
		'--exclude=src/VBox/Frontends/**' \
		'--exclude=src/VBox/VMM/**' \
		. $(VBOX_BLD_VM_LNX_IP):/mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)

validationkit-build-linux.build-it: validationkit-build-linux.rsync-into-vm
	$(call VBOX_BLD_VM_MSG_BEGIN,Linux/amd64 Validation Kit)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_LNX_IP)         'dchroot -c debian-4.0-amd64 "cd /mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.amd64) all " '
	$(call VBOX_BLD_VM_MSG_END__,Linux/amd64 Validation Kit)
	$(call VBOX_BLD_VM_MSG_BEGIN,Linux/x86 Validation Kit)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_LNX_IP) 'linux32 dchroot -c rhel3-i386       "cd /mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.x86)   all " '
	$(call VBOX_BLD_VM_MSG_END__,Linux/x86 Validation Kit)

validationkit-build-linux.rsync-out-of-vm: validationkit-build-linux.build-it
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_LNX_IP):/mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)/out/linux.x86   out/
	$(TIME) -- rsync -a --delete $(VBOX_BLD_VM_LNX_IP):/mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)/out/linux.amd64 out/

.PHONY:       validationkit-build-linux.rsync-out-of-vm validationkit-build-linux.rsync-into-vm validationkit-build-linux.build-it

validationkit-build-linux: validationkit-build-linux.rsync-out-of-vm
endif

validationkit-build-freebsd.amd64:   $(VBOX_VALIDATIONKIT_BUILD_WIN_HOST_FIRST)
#ifeq ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),freebsd.amd64)
#	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.amd64) all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)
#else
#	$(call VBOX_BLD_VM_MSG_BEGIN,Freebsd/amd64 Validation Kit)
#	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_FBSD_AMD64_IP) 'cd /mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.amd64) all '
#	$(call VBOX_BLD_VM_MSG_END__,Freebsd/amd64 Validation Kit)
#endif

validationkit-build-freebsd.x86:   $(VBOX_VALIDATIONKIT_BUILD_WIN_HOST_FIRST)
#ifeq ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),freebsd.x86)
#	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.x86) all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)
#else
#	$(call VBOX_BLD_VM_MSG_BEGIN,Freebsd/x86 Validation Kit)
#	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_FBSD_X86_IP) 'cd /mnt/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.x86) all '
#	$(call VBOX_BLD_VM_MSG_END__,Freebsd/x86 Validation Kit)
#endif

validationkit-build-darwin.amd64:   $(VBOX_VALIDATIONKIT_BUILD_WIN_HOST_FIRST)
ifeq ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),darwin.amd64)
	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.amd64) all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)
else
	$(call VBOX_BLD_VM_MSG_BEGIN,Darwin/amd64 Validation Kit)
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,darwin,amd64) . $(VBOX_BLD_VM_DARWIN_AMD64_IP):/Users/vbox/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_DARWIN_AMD64_IP) 'cd /Users/vbox/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.amd64) VBOX_DEF_MACOSX_VERSION_MIN=10.7 all '
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_DARWIN_AMD64_IP) 'cd /Users/vbox/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.amd64) VBOX_DEF_MACOSX_VERSION_MIN=10.7 packing '
	$(TIME) -- rsync -am -v --delete $(VBOX_BLD_VM_DARWIN_AMD64_IP):/Users/vbox/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)/out/darwin.amd64 out/
	$(call VBOX_BLD_VM_MSG_END__,Darwin/amd64 Validation Kit)
endif

validationkit-build-darwin.x86:   $(VBOX_VALIDATIONKIT_BUILD_WIN_HOST_FIRST)
ifeq ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),darwin.x86)
	+ $(TIME) -- $(KMK) $(VBOX_VALIDATIONKIT_BUILD.x86) all $(VBOX_VALIDATIONKIT_HOST_BUILD_TWEAK)
else
	$(call VBOX_BLD_VM_MSG_BEGIN,Darwin/x86 Validation Kit)
	$(TIME) -- $(call VBOX_RSYNC_IN_FN,darwin,x86) . $(VBOX_BLD_VM_DARWIN_X86_IP):/Users/vbox/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_DARWIN_X86_IP) 'cd /Users/vbox/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.x86) all ' ##@todo VBOX_DEF_MACOSX_VERSION_MIN=10.4 all
	$(TIME) -- ssh vbox@$(VBOX_BLD_VM_DARWIN_X86_IP) 'cd /Users/vbox/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME) && tools/env.sh --no-wine kmk $(VBOX_VALIDATIONKIT_BUILD.x86) packing ' ##@todo VBOX_DEF_MACOSX_VERSION_MIN=10.4 all
	$(TIME) -- rsync -am -v --delete $(VBOX_BLD_VM_DARWIN_X86_IP):/Users/vbox/tinderbox/$(VBOX_VALIDATIONKIT_BUILD_SUBDIRNAME)/out/darwin.x86 out/
	$(call VBOX_BLD_VM_MSG_END__,Darwin/x86 Validation Kit)
endif


validationkit-packing:
	+ $(KMK) VBOX_ONLY_VALIDATIONKIT=1 \
		VBOX_WITH_VALIDATIONKIT_PACKING.darwin.amd64=1 \
		VBOX_WITH_VALIDATIONKIT_PACKING.darwin.x86=2 \
		VBOX_WITH_VALIDATIONKIT_PACKING.freebsd.amd64= \
		VBOX_WITH_VALIDATIONKIT_PACKING.freebsd.x86= \
		VBOX_WITH_VALIDATIONKIT_PACKING.linux.amd64=1 \
		VBOX_WITH_VALIDATIONKIT_PACKING.linux.x86=1 \
		VBOX_WITH_VALIDATIONKIT_PACKING.os2.x86=1 \
		VBOX_WITH_VALIDATIONKIT_PACKING.solaris.amd64=1 \
		VBOX_WITH_VALIDATIONKIT_PACKING.solaris.x86=1 \
		VBOX_WITH_VALIDATIONKIT_PACKING.win.amd64=1 \
		VBOX_WITH_VALIDATIONKIT_PACKING.win.x86=1 \
		-C src/VBox/ValidationKit \
		$(PATH_OUT)/VBoxValidationKit.zip \
		$(PATH_OUT)/VBoxTestBoxScript.zip

.PHONY: \
	validationkit-build-win.x86 \
	validationkit-build-win.amd64 \
	validationkit-build-solaris.amd64 \
	validationkit-build-solaris.x86 \
	validationkit-build-os2.x86 \
	validationkit-build-linux \
	validationkit-build-linux.amd64 \
	validationkit-build-linux.x86 \
	validationkit-build-freebsd.amd64 \
	validationkit-build-freebsd.x86 \
	validationkit-build-darwin.amd64 \
	validationkit-build-darwin.x86 \
	validationkit-packing


#
# Build the EFI firmware, all of it.
#
efi-fetch:
	+ $(KMK) -C tools fetch VBOX_ONLY_EXTPACKS=1

efi-build: $(VBOX_VERSION_HEADER)
	+ $(KMK) -C src/VBox/Devices/EFI/Firmware$(VBOX_EFI_FIRMWARE_SUFFIX)

efi-packing:
	+ $(KMK) -C src/VBox/Devices/EFI/Firmware$(VBOX_EFI_FIRMWARE_SUFFIX) $(PATH_STAGE)/VBoxEfiFirmware.zip


#
# Generate VirtualBox-x.x.x.zip (PUEL) snapshot archive for internal use only
# - includes kBuild
# - must be executed on an PUEL checkout
#

# the path where to store the zip archive
ZIPPATH ?= $(abspath $(PATH_ROOT)/..)
# the root directory inside the zip archive
ZIPROOT ?= VirtualBox-$(VBOX_VERSION_STRING)
# the name of the zip archive
ZIPNAME ?= VirtualBox-$(VBOX_VERSION_STRING).zip
snapshot-puel:
	@$(call MSG_L1,Creating zip $(ZIPPATH)/$(ZIPNAME))
	@if [ ! -r "$(PATH_ROOT)/src/VBox/RDP/server/server.cpp" ]; then \
	    echo; \
	    echo "Did not find RDP stuff, is this an OSE branch?"; \
	    echo; \
	    exit 1; \
	 fi
	@if [ -z "$(PASSWORD)" ]; then \
	    echo; \
	    echo "Please specify a password with PASSWORD=..."; \
	    echo; \
	    exit 1; \
	 fi
	$(QUIET)$(MKDIR) -p $(ZIPPATH)
	$(QUIET)$(RM) -f $(ZIPPATH)/$(ZIPROOT)
	$(QUIET)$(RM) -f $(ZIPPATH)/$(ZIPNAME)
	$(QUIET)$(LN_SYMLINK) $(PATH_ROOT) $(ZIPPATH)/$(ZIPROOT)
	$(QUIET)(cd $(ZIPPATH); 7z a \
	    -l -tzip -mmt=on -mx=7 -p$(PASSWORD) \
	    -xr!.svn \
	    -i!$(ZIPROOT)/Config.kmk \
	    -i!$(ZIPROOT)/Doxyfile.Core \
	    -i!$(ZIPROOT)/Makefile.kmk \
	    -i!$(ZIPROOT)/configure \
	    -i!$(ZIPROOT)/configure.vbs \
	    -i!$(ZIPROOT)/doc \
	    -i!$(ZIPROOT)/include \
	    -i!$(ZIPROOT)/kBuild \
	    -i!$(ZIPROOT)/src \
	    -i!$(ZIPROOT)/tools/env.sh \
	    -i!$(ZIPROOT)/tools/linux.x86/bin/* \
	    -i!$(ZIPROOT)/tools/linux.amd64/bin/* \
	    -x!$(ZIPROOT)/doc/Devices \
	    -x!$(ZIPROOT)/doc/\*pdf \
	    -x!$(ZIPROOT)/doc/VMM \
	    -x!$(ZIPROOT)/doc/licenses_old \
	    -x!$(ZIPROOT)/doc/manual/de_DE \
	    -x!$(ZIPROOT)/doc/manual/fr_FR \
	    -x!$(ZIPROOT)/src/tests \
	    -x!$(ZIPROOT)/src/VBox/Artwork/2008-\* \
	    -x!$(ZIPROOT)/src/VBox/Installer/AMI \
	    -x!$(ZIPROOT)/src/VBox/Installer/Avanquest \
	    -x!$(ZIPROOT)/src/VBox/Installer/Encore \
	    -x!$(ZIPROOT)/src/VBox/Installer/linux/debian \
	    -x!$(ZIPROOT)/src/VBox/Installer/linux/rpm \
	    $(ZIPPATH)/$(ZIPNAME))
	$(QUIET)$(RM) $(ZIPPATH)/$(ZIPROOT)


#
# Generate VirtualBox-x.x.x.tar.bz2 (OSE) snapshot archive
# - includes kBuild
#

snapshot-ose:
ifndef VBOX_OSE
	$(QUIET)$(RM) -Rf $(wildcard $(PATH_OUT)/vbox-ose-snap-*) $(wildcard $(PATH_OUT)/VirtualBox-*.tar.bz2)
	$(call MSG_L1,Making OSE snapshot at $(PATH_OUT)/vbox-ose-snap-$(VBOX_VERSION_STRING))
	$(PATH_DEVTOOLS)/bin/ose-snapshot.sh $(PATH_OUT)/vbox-ose-snap-$(VBOX_VERSION_STRING)
	$(call MSG_L1,Creating OSE tarball $(PATH_OUT)/VirtualBox-$(VBOX_VERSION_STRING)-r$(VBOX_SVN_REV).tar.bz2)
	$(REDIRECT) -C $(PATH_OUT)/vbox-ose-snap-$(VBOX_VERSION_STRING) -- \
		$(PATH_DEVTOOLS)/bin/ose-tarball.sh $(PATH_OUT)/VirtualBox-$(VBOX_VERSION_STRING)-r$(VBOX_SVN_REV).tar.bz2
else
	$(QUIET)$(RM) $(wildcard $(PATH_OUT)/VirtualBox-*.tar.bz2)
	$(call MSG_L1,Creating OSE tarball $(PATH_OUT)/VirtualBox-$(VBOX_VERSION_STRING)-r$(VBOX_SVN_REV).tar.bz2)
	$(REDIRECT) -C $(PATH_ROOT) -- \
		$(PATH_DEVTOOLS)/bin/ose-tarball.sh $(PATH_OUT)/VirtualBox-$(VBOX_VERSION_STRING)-r$(VBOX_SVN_REV).tar.bz2
endif


#
# Generate ALL the rules.
#
include $(FILE_KBUILD_SUB_FOOTER)


#
# Generate x86.mac and err.mac.
#
incs:
	$(SED) -f include/VBox/err.sed     --output include/VBox/err.mac           include/VBox/err.h
	$(APPEND) include/VBox/err.mac '%include "iprt/err.mac"'
	$(SED) -f include/VBox/err.sed     --output include/iprt/err.mac           include/iprt/err.h
	$(SED) -f include/VBox/various.sed --output include/iprt/x86.mac           include/iprt/x86.h
	$(SED) -f include/VBox/various.sed --output include/iprt/formats/dwarf.mac include/iprt/formats/dwarf.h
	$(APPEND) include/iprt/x86.mac '%include "iprt/x86extra.mac"'
	$(SED) -f include/VBox/various.sed --output include/VBox/apic.mac          include/VBox/apic.h
	$(SED) -f include/VBox/various.sed --output include/VBox/bios.mac          include/VBox/bios.h
	$(SED) -f include/VBox/various.sed --output include/VBox/param.mac         include/VBox/param.h
	$(SED) -f include/VBox/various.sed --output include/VBox/VMMDevTesting.mac include/VBox/VMMDevTesting.h


#
# Legacy.
#
vslick.h:
	$(ECHO) This is now done by gen-slickedit-workspace.sh/cmd.
	exit 1


#
# Add fetching of the tools to the 'up[date][2]' targets.
#
up update up2 update2::
ifndef VBOX_OSE
	+$(MAKE) -C tools fetch
else
	$(MAKE) -C tools -f Makefile-ose.kmk fetch
endif



#
# Aliases for building the SDK.
#
.NOTPARALLEL: sdk sdk-fetch
sdk:
	+ $(KMK) VBOX_ONLY_SDK=1 \
		pass_bldprogs pass_others pass_installs pass_packing

sdk-fetch:
	+ $(KMK) VBOX_ONLY_SDK=1 -C tools


#
# Build the essentials to run a VM.  Incomplete. Use with care!
#
quick: \
	VBoxRT \
	VBoxVMM \
	VMMR0 \
	VBoxDD \
	VBoxDDR0 \
	VBoxDD2 \
	VBoxDD2R0 \
	VBoxC \
	VBoxSVC \
	$(if-expr defined(VBOX_WITH_RAW_MODE),VMMRC VBoxDDRC VBoxDD2RC,) \
	$(if-expr defined(VBOX_WITH_REM),VBoxREM,) \
	$(if-expr defined(VBOX_WITH_MIDL_PROXY_STUB) && "$(KBUILD_TARGET)" == "win",VBoxProxyStub,) \
	$(if-expr defined(VBOX_WITH_SDS),VBoxSDS,) \
	$(if-expr defined(VBOX_WITH_QTGUI),VirtualBox,)

